searchNodes=[{"type":"module","title":"GenAI","doc":"","ref":"GenAI.html"},{"type":"function","title":"GenAI.chat/2","doc":"Creates a new chat context.","ref":"GenAI.html#chat/2"},{"type":"function","title":"GenAI.execute/4","doc":"Execute command. # Notes Used, for example, to retrieve full report of a thread with an optimization loop or data loop command. Under usual processing not final/accepted grid search loops are not returned in response and a linear thread is returned. Execute mode however will return a graph of all runs, or meta data based on options, and grid search configuration.","ref":"GenAI.html#execute/4"},{"type":"function","title":"GenAI.report/3","doc":"Shorthand for execute report","ref":"GenAI.html#report/3"},{"type":"function","title":"GenAI.run/1","doc":"Run inference. Returning update chat completion and updated thread state.","ref":"GenAI.html#run/1"},{"type":"function","title":"GenAI.run/3","doc":"","ref":"GenAI.html#run/3"},{"type":"function","title":"GenAI.stream/3","doc":"Run inference in streaming mode, interstitial messages (dynamics) if any will sent to the stream handler using the interstitial handle","ref":"GenAI.html#stream/3"},{"type":"function","title":"GenAI.with_api_key/3","doc":"Set API Key or API Key constraint for inference. @todo we will need per model keys for ollam and hugging face.","ref":"GenAI.html#with_api_key/3"},{"type":"function","title":"GenAI.with_api_org/3","doc":"Set API Org or API Org constraint for inference.","ref":"GenAI.html#with_api_org/3"},{"type":"function","title":"GenAI.with_message/3","doc":"Append message to thread. @note Message may be dynamic/generated.","ref":"GenAI.html#with_message/3"},{"type":"function","title":"GenAI.with_messages/3","doc":"Append messages to thread. @note Messages may be dynamic/generated.","ref":"GenAI.html#with_messages/3"},{"type":"function","title":"GenAI.with_model/2","doc":"Set model or model selector constraint for inference.","ref":"GenAI.html#with_model/2"},{"type":"function","title":"GenAI.with_model_setting/2","doc":"See GenAI.ThreadProtocol.with_model_setting/2 .","ref":"GenAI.html#with_model_setting/2"},{"type":"function","title":"GenAI.with_model_setting/4","doc":"See GenAI.ThreadProtocol.with_model_setting/4 .","ref":"GenAI.html#with_model_setting/4"},{"type":"function","title":"GenAI.with_provider_setting/2","doc":"See GenAI.ThreadProtocol.with_provider_setting/2 .","ref":"GenAI.html#with_provider_setting/2"},{"type":"function","title":"GenAI.with_provider_setting/4","doc":"See GenAI.ThreadProtocol.with_provider_setting/4 .","ref":"GenAI.html#with_provider_setting/4"},{"type":"function","title":"GenAI.with_provider_settings/2","doc":"See GenAI.ThreadProtocol.with_provider_settings/2 .","ref":"GenAI.html#with_provider_settings/2"},{"type":"function","title":"GenAI.with_provider_settings/3","doc":"See GenAI.ThreadProtocol.with_provider_settings/3 .","ref":"GenAI.html#with_provider_settings/3"},{"type":"function","title":"GenAI.with_safety_setting/2","doc":"See GenAI.ThreadProtocol.with_safety_setting/2 .","ref":"GenAI.html#with_safety_setting/2"},{"type":"function","title":"GenAI.with_safety_setting/3","doc":"Set safety setting for inference. @note - only fully supported by Gemini. backwards compatibility can be enabled via prompting but will be less reliable.","ref":"GenAI.html#with_safety_setting/3"},{"type":"function","title":"GenAI.with_setting/2","doc":"Set setting or setting selector constraint for inference.","ref":"GenAI.html#with_setting/2"},{"type":"function","title":"GenAI.with_setting/3","doc":"Set Inference setting. GenAI.Session","ref":"GenAI.html#with_setting/3"},{"type":"function","title":"GenAI.with_settings/2","doc":"Set settings setting selector constraints for inference.","ref":"GenAI.html#with_settings/2"},{"type":"function","title":"GenAI.with_stream_handler/3","doc":"Override streaming handler module.","ref":"GenAI.html#with_stream_handler/3"},{"type":"function","title":"GenAI.with_tool/2","doc":"Set tool for inference.","ref":"GenAI.html#with_tool/2"},{"type":"function","title":"GenAI.with_tools/2","doc":"Set tools for inference.","ref":"GenAI.html#with_tools/2"},{"type":"module","title":"GenAI.ChatCompletion","doc":"Encodes a LLM ChatCompletion response.","ref":"GenAI.ChatCompletion.html"},{"type":"function","title":"GenAI.ChatCompletion.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.ChatCompletion.html#description/1"},{"type":"function","title":"GenAI.ChatCompletion.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.ChatCompletion.html#description/2"},{"type":"function","title":"GenAI.ChatCompletion.from_json/1","doc":"","ref":"GenAI.ChatCompletion.html#from_json/1"},{"type":"function","title":"GenAI.ChatCompletion.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.ChatCompletion.html#handle/1"},{"type":"function","title":"GenAI.ChatCompletion.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.ChatCompletion.html#handle/2"},{"type":"function","title":"GenAI.ChatCompletion.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.ChatCompletion.html#id/1"},{"type":"function","title":"GenAI.ChatCompletion.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.ChatCompletion.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.ChatCompletion.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.ChatCompletion.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.ChatCompletion.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.ChatCompletion.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.ChatCompletion.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.ChatCompletion.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.ChatCompletion.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.ChatCompletion.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.ChatCompletion.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.ChatCompletion.html#name/1"},{"type":"function","title":"GenAI.ChatCompletion.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.ChatCompletion.html#name/2"},{"type":"function","title":"GenAI.ChatCompletion.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.ChatCompletion.html#new/1"},{"type":"type","title":"GenAI.ChatCompletion.t/0","doc":"","ref":"GenAI.ChatCompletion.html#t:t/0"},{"type":"module","title":"GenAI.ChatCompletion.Choice","doc":"","ref":"GenAI.ChatCompletion.Choice.html"},{"type":"function","title":"GenAI.ChatCompletion.Choice.new/1","doc":"","ref":"GenAI.ChatCompletion.Choice.html#new/1"},{"type":"module","title":"GenAI.ChatCompletion.Usage","doc":"","ref":"GenAI.ChatCompletion.Usage.html"},{"type":"function","title":"GenAI.ChatCompletion.Usage.new/1","doc":"","ref":"GenAI.ChatCompletion.Usage.html#new/1"},{"type":"module","title":"GenAI.Config","doc":"Module for fetching, and setting global or per process default config settings.","ref":"GenAI.Config.html"},{"type":"function","title":"GenAI.Config.reset/1","doc":"","ref":"GenAI.Config.html#reset/1"},{"type":"module","title":"GenAI.Document.ContentBlock","doc":"","ref":"GenAI.Document.ContentBlock.html"},{"type":"function","title":"GenAI.Document.ContentBlock.new/1","doc":"","ref":"GenAI.Document.ContentBlock.html#new/1"},{"type":"module","title":"GenAI.Document.Link","doc":"","ref":"GenAI.Document.Link.html"},{"type":"function","title":"GenAI.Document.Link.new/1","doc":"","ref":"GenAI.Document.Link.html#new/1"},{"type":"module","title":"GenAI.Document.PDF","doc":"","ref":"GenAI.Document.PDF.html"},{"type":"function","title":"GenAI.Document.PDF.new/1","doc":"","ref":"GenAI.Document.PDF.html#new/1"},{"type":"module","title":"GenAI.Document.Text","doc":"","ref":"GenAI.Document.Text.html"},{"type":"function","title":"GenAI.Document.Text.new/1","doc":"","ref":"GenAI.Document.Text.html#new/1"},{"type":"module","title":"GenAI.ExternalModel","doc":"","ref":"GenAI.ExternalModel.html"},{"type":"function","title":"GenAI.ExternalModel.apply_node_directives/6","doc":"","ref":"GenAI.ExternalModel.html#apply_node_directives/6"},{"type":"function","title":"GenAI.ExternalModel.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.ExternalModel.html#description/1"},{"type":"function","title":"GenAI.ExternalModel.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.ExternalModel.html#description/2"},{"type":"function","title":"GenAI.ExternalModel.do_node_type/1","doc":"","ref":"GenAI.ExternalModel.html#do_node_type/1"},{"type":"function","title":"GenAI.ExternalModel.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.ExternalModel.html#handle/1"},{"type":"function","title":"GenAI.ExternalModel.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.ExternalModel.html#handle/2"},{"type":"function","title":"GenAI.ExternalModel.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.ExternalModel.html#id/1"},{"type":"function","title":"GenAI.ExternalModel.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.ExternalModel.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.ExternalModel.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.ExternalModel.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.ExternalModel.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.ExternalModel.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.ExternalModel.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.ExternalModel.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.ExternalModel.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.ExternalModel.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.ExternalModel.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.ExternalModel.html#name/1"},{"type":"function","title":"GenAI.ExternalModel.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.ExternalModel.html#name/2"},{"type":"function","title":"GenAI.ExternalModel.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.ExternalModel.html#new/1"},{"type":"type","title":"GenAI.ExternalModel.t/0","doc":"","ref":"GenAI.ExternalModel.html#t:t/0"},{"type":"module","title":"GenAI.Graph","doc":"A module representing a graph structure in the GenAI system. This module defines the structure and behavior of a graph, including its nodes and the ability to append new nodes.","ref":"GenAI.Graph.html"},{"type":"function","title":"GenAI.Graph.append_node/2","doc":"Appends a new node to the graph.","ref":"GenAI.Graph.html#append_node/2"},{"type":"module","title":"GenAI.Graph.Link","doc":"Represent a link between two nodes in a graph.","ref":"GenAI.Graph.Link.html"},{"type":"function","title":"GenAI.Graph.Link.description/1","doc":"Obtain the description of a graph link. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , description : &quot;B&quot; ) ...&gt; GenAI.Graph.Link . description ( l ) { :ok , &quot;B&quot; } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . description ( l ) { :error , { :description , :is_nil } }","ref":"GenAI.Graph.Link.html#description/1"},{"type":"function","title":"GenAI.Graph.Link.description/2","doc":"Obtain the description of a graph link, or return a default value if the description is nil. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , description : &quot;B&quot; ) ...&gt; GenAI.Graph.Link . description ( l , &quot;default&quot; ) { :ok , &quot;B&quot; } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . description ( l , &quot;default&quot; ) { :ok , &quot;default&quot; }","ref":"GenAI.Graph.Link.html#description/2"},{"type":"function","title":"GenAI.Graph.Link.handle/1","doc":"Obtain the handle of a graph link. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , handle : :foo ) ...&gt; GenAI.Graph.Link . handle ( l ) { :ok , :foo } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . handle ( l ) { :error , { :handle , :is_nil } }","ref":"GenAI.Graph.Link.html#handle/1"},{"type":"function","title":"GenAI.Graph.Link.handle/2","doc":"Obtain the handle of a graph link, or return a default value if the handle is nil. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , handle : :foo ) ...&gt; GenAI.Graph.Link . handle ( l , :default ) { :ok , :foo } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . handle ( l , :default ) { :ok , :default }","ref":"GenAI.Graph.Link.html#handle/2"},{"type":"function","title":"GenAI.Graph.Link.id/1","doc":"Obtain the id of a graph link. Examples when set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , handle : :foo , name : &quot;A&quot; , description : &quot;B&quot; ) ...&gt; GenAI.Graph.Link . id ( l ) { :ok , l . id } when not set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , handle : :foo , name : &quot;A&quot; , description : &quot;B&quot; ) |&gt; put_in ( [ Access . key ( :id ) ] , nil ) ...&gt; GenAI.Graph.Link . id ( l ) { :error , { :id , :is_nil } }","ref":"GenAI.Graph.Link.html#id/1"},{"type":"function","title":"GenAI.Graph.Link.label/1","doc":"Obtain the label of a graph link. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , label : :some_label ) ...&gt; GenAI.Graph.Link . label ( l ) { :ok , :some_label } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . label ( l ) { :error , { :label , :is_nil } }","ref":"GenAI.Graph.Link.html#label/1"},{"type":"function","title":"GenAI.Graph.Link.label/2","doc":"Obtain the label of a graph link, or return a default value if the label is nil. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , label : :my_label ) ...&gt; GenAI.Graph.Link . label ( l , :default ) { :ok , :my_label } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . label ( l , :default ) { :ok , :default }","ref":"GenAI.Graph.Link.html#label/2"},{"type":"function","title":"GenAI.Graph.Link.name/1","doc":"Obtain the name of a graph link. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , name : &quot;A&quot; ) ...&gt; GenAI.Graph.Link . name ( l ) { :ok , &quot;A&quot; } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . name ( l ) { :error , { :name , :is_nil } }","ref":"GenAI.Graph.Link.html#name/1"},{"type":"function","title":"GenAI.Graph.Link.name/2","doc":"Obtain the name of a graph link, or return a default value if the name is nil. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , name : &quot;A&quot; ) ...&gt; GenAI.Graph.Link . name ( l , &quot;default&quot; ) { :ok , &quot;A&quot; } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; GenAI.Graph.Link . name ( l , &quot;default&quot; ) { :ok , &quot;default&quot; }","ref":"GenAI.Graph.Link.html#name/2"},{"type":"function","title":"GenAI.Graph.Link.new/3","doc":"Create a new link. Examples iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) iex&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) iex&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , name : &quot;Hello&quot; ) % GenAI.Graph.Link { handle : nil , name : &quot;Hello&quot; , description : nil , source : R.Link . connector ( node : ^ node1_id , socket : :default , external : false ) , target : R.Link . connector ( node : ^ node2_id , socket : :default , external : false ) , vsn : 1.0 } = l iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) iex&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) iex&gt; l = GenAI.Graph.Link . new ( R.Link . connector ( node : node1_id , socket : :default , external : false ) , node2_id , handle : :andy ) % GenAI.Graph.Link { handle : :andy , source : R.Link . connector ( node : ^ node1_id , socket : :default , external : false ) , target : R.Link . connector ( node : ^ node2_id , socket : :default , external : false ) , vsn : 1.0 } = l iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) iex&gt; l = GenAI.Graph.Link . new ( R.Link . connector ( node : node1_id , socket : :default , external : false ) , nil , description : &quot;A Node&quot; ) % GenAI.Graph.Link { description : &quot;A Node&quot; , source : R.Link . connector ( node : ^ node1_id , socket : :default , external : false ) , target : R.Link . connector ( node : nil , socket : :default , external : true ) , vsn : 1.0 } = l # from node struct (requires protocol impl)","ref":"GenAI.Graph.Link.html#new/3"},{"type":"function","title":"GenAI.Graph.Link.putnew_source/2","doc":"Set the source connector of a graph link, if it is not already set. Examples When Not Set. By ID iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( nil , node2_id ) ...&gt; |&gt; GenAI.Graph.Link . putnew_source ( node1_id ) % GenAI.Graph.Link { source : R.Link . connector ( node : ^ node1_id , external : false ) } = l When Not Set. By Connector iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( nil , node2_id ) ...&gt; |&gt; GenAI.Graph.Link . putnew_source ( R.Link . connector ( node : node1_id , socket : :foo , external : false ) ) % GenAI.Graph.Link { source : R.Link . connector ( node : ^ node1_id , socket : :foo , external : false ) } = l When Set. By ID iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; node3_id = UUID . uuid5 ( :oid , &quot;node-3&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; |&gt; GenAI.Graph.Link . putnew_source ( node3_id ) % GenAI.Graph.Link { source : R.Link . connector ( node : ^ node1_id , external : false ) } = l When Set. By Connector iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; node3_id = UUID . uuid5 ( :oid , &quot;node-3&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; |&gt; GenAI.Graph.Link . putnew_source ( R.Link . connector ( node : node3_id , socket : :foo , external : false ) ) % GenAI.Graph.Link { source : R.Link . connector ( node : ^ node1_id , external : false ) } = l","ref":"GenAI.Graph.Link.html#putnew_source/2"},{"type":"function","title":"GenAI.Graph.Link.putnew_target/2","doc":"Set the target connector of a graph link, if it is not already set. Examples When Not Set. By ID iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , nil ) ...&gt; |&gt; GenAI.Graph.Link . putnew_target ( node2_id ) % GenAI.Graph.Link { target : R.Link . connector ( node : ^ node2_id , external : false ) } = l When Not Set. By Connector iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , nil ) ...&gt; |&gt; GenAI.Graph.Link . putnew_target ( R.Link . connector ( node : node2_id , socket : :foo , external : false ) ) % GenAI.Graph.Link { target : R.Link . connector ( node : ^ node2_id , external : false ) } = l When Set. By ID iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; node3_id = UUID . uuid5 ( :oid , &quot;node-3&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; |&gt; GenAI.Graph.Link . putnew_target ( node3_id ) % GenAI.Graph.Link { target : R.Link . connector ( node : ^ node2_id , external : false ) } = l When Set. By Connector iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; node3_id = UUID . uuid5 ( :oid , &quot;node-3&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; |&gt; GenAI.Graph.Link . putnew_target ( R.Link . connector ( node : node3_id , socket : :foo , external : false ) ) % GenAI.Graph.Link { target : R.Link . connector ( node : ^ node2_id , external : false ) } = l","ref":"GenAI.Graph.Link.html#putnew_target/2"},{"type":"function","title":"GenAI.Graph.Link.source_connector/1","doc":"Obtain the source connector of a graph link. Examples iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; { :ok , sut } = GenAI.Graph.Link . source_connector ( l ) ...&gt; sut R.Link . connector ( external : false ) = sut iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; l = GenAI.Graph.Link . new ( nil , node1_id ) ...&gt; { :ok , sut } = GenAI.Graph.Link . source_connector ( l ) ...&gt; sut R.Link . connector ( external : true ) = sut","ref":"GenAI.Graph.Link.html#source_connector/1"},{"type":"function","title":"GenAI.Graph.Link.target_connector/1","doc":"Obtain the target connector of a graph link. Examples iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; { :ok , sut } = GenAI.Graph.Link . target_connector ( l ) ...&gt; sut R.Link . connector ( node : ^ node2_id ) = sut iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , nil ) ...&gt; { :ok , sut } = GenAI.Graph.Link . target_connector ( l ) ...&gt; sut R.Link . connector ( external : true ) = sut","ref":"GenAI.Graph.Link.html#target_connector/1"},{"type":"function","title":"GenAI.Graph.Link.type/1","doc":"Obtain the type of a graph link. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , type : :link_type ) ...&gt; GenAI.Graph.Link . type ( l ) { :ok , :link_type } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , type : nil ) ...&gt; GenAI.Graph.Link . type ( l ) { :error , { :type , :is_nil } }","ref":"GenAI.Graph.Link.html#type/1"},{"type":"function","title":"GenAI.Graph.Link.type/2","doc":"Obtain the type of a graph link, or return a default value if the type is nil. Examples When Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , type : :link_type ) ...&gt; GenAI.Graph.Link . type ( l , :default ) { :ok , :link_type } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id , type : nil ) ...&gt; GenAI.Graph.Link . type ( l , :default ) { :ok , :default }","ref":"GenAI.Graph.Link.html#type/2"},{"type":"function","title":"GenAI.Graph.Link.with_id/1","doc":"Ensure the graph link has an id, generating one if necessary. Examples When Already Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) ...&gt; { :ok , l2 } = GenAI.Graph.Link . with_id ( l ) ...&gt; %{ was_nil : is_nil ( l . id ) , is_nil : is_nil ( l2 . id ) , id_change : l . id != l2 . id } %{ was_nil : false , is_nil : false , id_change : false } When Not Set iex&gt; node1_id = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; node2_id = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; l = GenAI.Graph.Link . new ( node1_id , node2_id ) |&gt; put_in ( [ Access . key ( :id ) ] , nil ) ...&gt; { :ok , l2 } = GenAI.Graph.Link . with_id ( l ) ...&gt; %{ was_nil : is_nil ( l . id ) , is_nil : is_nil ( l2 . id ) , id_change : l . id != l2 . id } %{ was_nil : true , is_nil : false , id_change : true }","ref":"GenAI.Graph.Link.html#with_id/1"},{"type":"function","title":"GenAI.Graph.Link.with_id!/1","doc":"","ref":"GenAI.Graph.Link.html#with_id!/1"},{"type":"type","title":"GenAI.Graph.Link.t/0","doc":"","ref":"GenAI.Graph.Link.html#t:t/0"},{"type":"protocol","title":"GenAI.Graph.MermaidProtocol","doc":"Mermaid Encode Protocol.","ref":"GenAI.Graph.MermaidProtocol.html"},{"type":"function","title":"GenAI.Graph.MermaidProtocol.encode/1","doc":"Convert element to mermaid output.","ref":"GenAI.Graph.MermaidProtocol.html#encode/1"},{"type":"function","title":"GenAI.Graph.MermaidProtocol.encode/2","doc":"Convert element to mermaid output.","ref":"GenAI.Graph.MermaidProtocol.html#encode/2"},{"type":"function","title":"GenAI.Graph.MermaidProtocol.encode/3","doc":"Convert element to mermaid output.","ref":"GenAI.Graph.MermaidProtocol.html#encode/3"},{"type":"function","title":"GenAI.Graph.MermaidProtocol.mermaid_id/1","doc":"Format an ID for use in a Mermaid diagram.","ref":"GenAI.Graph.MermaidProtocol.html#mermaid_id/1"},{"type":"type","title":"GenAI.Graph.MermaidProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.Graph.MermaidProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Graph.MermaidProtocol.Helpers","doc":"Helpers for generating Mermaid graphs using the GenAI.Graph.MermaidProtocol protocol.","ref":"GenAI.Graph.MermaidProtocol.Helpers.html"},{"type":"function","title":"GenAI.Graph.MermaidProtocol.Helpers.diagram_type/1","doc":"Return the diagram type.","ref":"GenAI.Graph.MermaidProtocol.Helpers.html#diagram_type/1"},{"type":"function","title":"GenAI.Graph.MermaidProtocol.Helpers.indent/2","doc":"Indent a string by a given depth.","ref":"GenAI.Graph.MermaidProtocol.Helpers.html#indent/2"},{"type":"function","title":"GenAI.Graph.MermaidProtocol.Helpers.mermaid_id/1","doc":"Format id for mermaid compatibility.","ref":"GenAI.Graph.MermaidProtocol.Helpers.html#mermaid_id/1"},{"type":"module","title":"GenAI.Graph.Node","doc":"Represent a node on graph (generic type).","ref":"GenAI.Graph.Node.html"},{"type":"function","title":"GenAI.Graph.Node.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Graph.Node.html#description/1"},{"type":"function","title":"GenAI.Graph.Node.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Graph.Node.html#description/2"},{"type":"function","title":"GenAI.Graph.Node.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Graph.Node.html#handle/1"},{"type":"function","title":"GenAI.Graph.Node.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Graph.Node.html#handle/2"},{"type":"function","title":"GenAI.Graph.Node.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Graph.Node.html#id/1"},{"type":"function","title":"GenAI.Graph.Node.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Graph.Node.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Graph.Node.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Graph.Node.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Graph.Node.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Graph.Node.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Graph.Node.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Graph.Node.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Graph.Node.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Graph.Node.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Graph.Node.is_node?/1","doc":"","ref":"GenAI.Graph.Node.html#is_node?/1"},{"type":"function","title":"GenAI.Graph.Node.is_node?/2","doc":"","ref":"GenAI.Graph.Node.html#is_node?/2"},{"type":"function","title":"GenAI.Graph.Node.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Graph.Node.html#name/1"},{"type":"function","title":"GenAI.Graph.Node.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Graph.Node.html#name/2"},{"type":"function","title":"GenAI.Graph.Node.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Graph.Node.html#new/1"},{"type":"type","title":"GenAI.Graph.Node.t/0","doc":"","ref":"GenAI.Graph.Node.html#t:t/0"},{"type":"behaviour","title":"GenAI.Graph.NodeBehaviour","doc":"Behaviour Graph Node Elements must adhere to.","ref":"GenAI.Graph.NodeBehaviour.html"},{"type":"macro","title":"GenAI.Graph.NodeBehaviour.defnodestruct/1","doc":"Define the struct of a node with default fields included. Example defnodestruct [ value : nil , ]","ref":"GenAI.Graph.NodeBehaviour.html#defnodestruct/1"},{"type":"macro","title":"GenAI.Graph.NodeBehaviour.defnodetype/1","doc":"Define the type of a node with default fields included. Example defnodetype [ internal : boolean , ]","ref":"GenAI.Graph.NodeBehaviour.html#defnodetype/1"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.description/1","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:description/1"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.description/2","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:description/2"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.handle/1","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:handle/1"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.handle/2","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:handle/2"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.id/1","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:id/1"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.name/1","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:name/1"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.name/2","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:name/2"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.new/0","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:new/0"},{"type":"callback","title":"GenAI.Graph.NodeBehaviour.new/1","doc":"","ref":"GenAI.Graph.NodeBehaviour.html#c:new/1"},{"type":"protocol","title":"GenAI.Graph.NodeProtocol","doc":"Protocol for managing Graph Nodes.","ref":"GenAI.Graph.NodeProtocol.html"},{"type":"function","title":"GenAI.Graph.NodeProtocol.build_handle_lookup/2","doc":"build handle lookup table for graph root, including local handles that can override standard handles based on scope.","ref":"GenAI.Graph.NodeProtocol.html#build_handle_lookup/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.build_node_lookup/2","doc":"build Graph Root node lookup allowing nodes to link across descendents/siblings to far away elements.","ref":"GenAI.Graph.NodeProtocol.html#build_node_lookup/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.description/1","doc":"Obtain the description of a graph node. Examples When Set iex&gt; node = % GenAI.Graph.Node { description : &quot;B&quot; } ...&gt; GenAI.Graph.NodeProtocol . description ( node ) { :ok , &quot;B&quot; } When Not Set iex&gt; node = % GenAI.Graph.Node { description : nil } ...&gt; GenAI.Graph.NodeProtocol . description ( node ) { :error , { :description , :is_nil } }","ref":"GenAI.Graph.NodeProtocol.html#description/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.description/2","doc":"Obtain the description of a graph node, or return a default value if the description is nil. Examples When Set iex&gt; node = % GenAI.Graph.Node { description : &quot;B&quot; } ...&gt; GenAI.Graph.NodeProtocol . description ( node , &quot;default&quot; ) { :ok , &quot;B&quot; } When Not Set iex&gt; node = % GenAI.Graph.Node { description : nil } ...&gt; GenAI.Graph.NodeProtocol . description ( node , &quot;default&quot; ) { :ok , &quot;default&quot; }","ref":"GenAI.Graph.NodeProtocol.html#description/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.handle/1","doc":"Obtain the handle of a graph node. Examples When Set iex&gt; node = % GenAI.Graph.Node { handle : :foo } ...&gt; GenAI.Graph.NodeProtocol . handle ( node ) { :ok , :foo } When Not Set iex&gt; node = % GenAI.Graph.Node { handle : nil } ...&gt; GenAI.Graph.NodeProtocol . handle ( node ) { :error , { :handle , :is_nil } }","ref":"GenAI.Graph.NodeProtocol.html#handle/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.handle/2","doc":"Obtain the handle of a graph node, or return a default value if the handle is nil. Examples When Set iex&gt; node = % GenAI.Graph.Node { handle : :foo } ...&gt; GenAI.Graph.NodeProtocol . handle ( node , :default ) { :ok , :foo } When Not Set iex&gt; node = % GenAI.Graph.Node { handle : nil } ...&gt; GenAI.Graph.NodeProtocol . handle ( node , :default ) { :ok , :default }","ref":"GenAI.Graph.NodeProtocol.html#handle/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.handle_record/1","doc":"Return full handle record not just the handle name.","ref":"GenAI.Graph.NodeProtocol.html#handle_record/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.id/1","doc":"Obtain the id of a graph node. Examples When Set iex&gt; node = % GenAI.Graph.Node { id : UUID . uuid4 ( ) } ...&gt; GenAI.Graph.NodeProtocol . id ( node ) { :ok , node . id } When Not Set iex&gt; node = % GenAI.Graph.Node { id : nil } ...&gt; GenAI.Graph.NodeProtocol . id ( node ) { :error , { :id , :is_nil } }","ref":"GenAI.Graph.NodeProtocol.html#id/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.inbound_links/3","doc":"Obtain inbound links of a graph node.","ref":"GenAI.Graph.NodeProtocol.html#inbound_links/3"},{"type":"function","title":"GenAI.Graph.NodeProtocol.name/1","doc":"Obtain the name of a graph node. Examples When Set iex&gt; node = % GenAI.Graph.Node { name : &quot;A&quot; } ...&gt; GenAI.Graph.NodeProtocol . name ( node ) { :ok , &quot;A&quot; } When Not Set iex&gt; node = % GenAI.Graph.Node { name : nil } ...&gt; GenAI.Graph.NodeProtocol . name ( node ) { :error , { :name , :is_nil } }","ref":"GenAI.Graph.NodeProtocol.html#name/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.name/2","doc":"Obtain the name of a graph node, or return a default value if the name is nil. Examples When Set iex&gt; node = % GenAI.Graph.Node { name : &quot;A&quot; } ...&gt; GenAI.Graph.NodeProtocol . name ( node , &quot;default&quot; ) { :ok , &quot;A&quot; } When Not Set iex&gt; node = % GenAI.Graph.Node { name : nil } ...&gt; GenAI.Graph.NodeProtocol . name ( node , &quot;default&quot; ) { :ok , &quot;default&quot; }","ref":"GenAI.Graph.NodeProtocol.html#name/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.node/2","doc":"Obtain a node nested under current node,","ref":"GenAI.Graph.NodeProtocol.html#node/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.node_type/1","doc":"Obtain the node type for a graph node. Example iex&gt; node = % GenAI.Graph.Node { id : UUID . uuid4 ( ) } ...&gt; GenAI.Graph.NodeProtocol . node_type ( node ) { :ok , GenAI.Graph.Node }","ref":"GenAI.Graph.NodeProtocol.html#node_type/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.nodes/2","doc":"Obtain direct children node of current node.","ref":"GenAI.Graph.NodeProtocol.html#nodes/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.outbound_links/3","doc":"Obtain outbound links of a graph node.","ref":"GenAI.Graph.NodeProtocol.html#outbound_links/3"},{"type":"function","title":"GenAI.Graph.NodeProtocol.process_node/6","doc":"Process graph to execute tasks or run inference.","ref":"GenAI.Graph.NodeProtocol.html#process_node/6"},{"type":"function","title":"GenAI.Graph.NodeProtocol.register_link/4","doc":"Register a link with the graph node. Examples iex&gt; n1 = UUID . uuid5 ( :oid , &quot;node-1&quot; ) ...&gt; n2 = UUID . uuid5 ( :oid , &quot;node-2&quot; ) ...&gt; n = % GenAI.Graph.Node { id : n1 } ...&gt; link = GenAI.Graph.Link . new ( n1 , n2 ) ...&gt; link_id = link . id ...&gt; { :ok , updated } = GenAI.Graph.NodeProtocol . register_link ( n , %{ } , link , nil ) ...&gt; updated % GenAI.Graph.Node { outbound_links : %{ default : [ ^ link_id ] } } = updated","ref":"GenAI.Graph.NodeProtocol.html#register_link/4"},{"type":"function","title":"GenAI.Graph.NodeProtocol.with_id/1","doc":"Ensure the graph node has an id, generating one if necessary. Examples When Already Set iex&gt; node = % GenAI.Graph.Node { id : UUID . uuid4 ( ) } ...&gt; { :ok , node2 } = GenAI.Graph.NodeProtocol . with_id ( node ) ...&gt; %{ was_nil : is_nil ( node . id ) , is_nil : is_nil ( node2 . id ) , id_change : node . id != node2 . id } %{ was_nil : false , is_nil : false , id_change : false } When Not Set iex&gt; node = % GenAI.Graph.Node { id : nil } ...&gt; { :ok , node2 } = GenAI.Graph.NodeProtocol . with_id ( node ) ...&gt; %{ was_nil : is_nil ( node . id ) , is_nil : is_nil ( node2 . id ) , id_change : node . id != node2 . id } %{ was_nil : true , is_nil : false , id_change : true }","ref":"GenAI.Graph.NodeProtocol.html#with_id/1"},{"type":"type","title":"GenAI.Graph.NodeProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.Graph.NodeProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Graph.NodeProtocol.DefaultProvider","doc":"Default provider for GenAI.Graph.NodeProtocol. Uses function_exported? to invoke the passed module's implementation if any for calls.","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.apply_node_directives/6","doc":"Apply/process a node. check/update fingerprint and add any appropriate directives to state.","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.build_handle_lookup/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#build_handle_lookup/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.build_node_lookup/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#build_node_lookup/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.description/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#description/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.description/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#description/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_description/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_description/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_description/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_description/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_handle/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_handle/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_handle/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_handle/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_handle_record/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_handle_record/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_id/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_id/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_inbound_links/3","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_inbound_links/3"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_name/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_name/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_name/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_name/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_new/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_new/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_node_type/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_node_type/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_outbound_links/3","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_outbound_links/3"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_process_node/6","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_process_node/6"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_process_node_response/6","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_process_node_response/6"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_register_link/4","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_register_link/4"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_with_id/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_with_id/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.do_with_id!/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#do_with_id!/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.handle/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#handle/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.handle/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#handle/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.handle_record/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#handle_record/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.id/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#id/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.inbound_links/3","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#inbound_links/3"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.name/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#name/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.name/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#name/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.new/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#new/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.node/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#node/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.node_type/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#node_type/1"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.nodes/2","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#nodes/2"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.outbound_links/3","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#outbound_links/3"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.process_node/6","doc":"Apply/process a node. check/update fingerprint and add any appropriate directives to state.","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#process_node/6"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.process_node_response/6","doc":"Apply/process a node. check/update fingerprint and add any appropriate directives to state.","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#process_node_response/6"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.register_link/4","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#register_link/4"},{"type":"function","title":"GenAI.Graph.NodeProtocol.DefaultProvider.with_id/1","doc":"","ref":"GenAI.Graph.NodeProtocol.DefaultProvider.html#with_id/1"},{"type":"module","title":"GenAI.Graph.Root","doc":"The root data structure that contains nested graphs, nodes and other structures.","ref":"GenAI.Graph.Root.html"},{"type":"function","title":"GenAI.Graph.Root.element/2","doc":"Retrieve a nested element by id from graph","ref":"GenAI.Graph.Root.html#element/2"},{"type":"function","title":"GenAI.Graph.Root.element_by_handle/3","doc":"Retrieve a nested element by handle from graph","ref":"GenAI.Graph.Root.html#element_by_handle/3"},{"type":"function","title":"GenAI.Graph.Root.element_entry/2","doc":"Retrieve a element_lookup entry by element id.","ref":"GenAI.Graph.Root.html#element_entry/2"},{"type":"function","title":"GenAI.Graph.Root.get_nested_element/2","doc":"extract nested entry by path from source element.","ref":"GenAI.Graph.Root.html#get_nested_element/2"},{"type":"function","title":"GenAI.Graph.Root.graph_context_by_link/3","doc":"Retrieve graph context by link","ref":"GenAI.Graph.Root.html#graph_context_by_link/3"},{"type":"function","title":"GenAI.Graph.Root.handle_entry/3","doc":"Retrieve an element_lookup entry by handle and base node","ref":"GenAI.Graph.Root.html#handle_entry/3"},{"type":"function","title":"GenAI.Graph.Root.merge_handle/2","doc":"Merge a single graph handle entry into lookup table.","ref":"GenAI.Graph.Root.html#merge_handle/2"},{"type":"function","title":"GenAI.Graph.Root.merge_handles/2","doc":"Merge list of {handle, element or path to element} entries into lookup table.","ref":"GenAI.Graph.Root.html#merge_handles/2"},{"type":"function","title":"GenAI.Graph.Root.merge_lookup_table_entries/2","doc":"Merge element lookup entries","ref":"GenAI.Graph.Root.html#merge_lookup_table_entries/2"},{"type":"function","title":"GenAI.Graph.Root.nearest_handle_entry/3","doc":"Retrieve closest nested handle nested under base. If a global entry is found and under base it will be used. If a standard entry is found and under base it will be used. Only if no standard or global entry under base exists will locals be checked.","ref":"GenAI.Graph.Root.html#nearest_handle_entry/3"},{"type":"function","title":"GenAI.Graph.Root.process_node/6","doc":"","ref":"GenAI.Graph.Root.html#process_node/6"},{"type":"module","title":"GenAI.Helpers","doc":"A collection of helper functions for VNextGenAI.","ref":"GenAI.Helpers.html"},{"type":"function","title":"GenAI.Helpers.apply_label/2","doc":"label response Examples OK Response iex&gt; GenAI.Helpers . apply_label ( { :ok , :bar } , :foo ) { :foo , :bar } Error Response iex&gt; GenAI.Helpers . apply_label ( { :error , :bar } , :foo ) { :error , { :foo , :bar } } Non Tuple Response iex&gt; GenAI.Helpers . apply_label ( :bop , :foo ) { :foo , :bop }","ref":"GenAI.Helpers.html#apply_label/2"},{"type":"function","title":"GenAI.Helpers.on_error/3","doc":"Handle error tuple response. Examples iex&gt; {:ok, :return_me} |&gt; GenAI.Helpers.on_error(:label, :unexpected) iex&gt; {:ok, nil} |&gt; GenAI.Helpers.on_error(:label, :unexpected) iex&gt; {:error, :foo} |&gt; GenAI.Helpers.on_error(:return_value, :bar) iex&gt; {:error, :foo} |&gt; GenAI.Helpers.on_error(:return_error, :bar) iex&gt; {:error, :foo} |&gt; GenAI.Helpers.on_error(:return, :bar) :bar iex&gt; {:error, :foo} |&gt; GenAI.Helpers.on_error(:call, fn -&gt; :biz end) :biz iex&gt; {:error, :foo} |&gt; GenAI.Helpers.on_error(:call, fn x -&gt; {:biz, x} end) {:biz, {:error, :foo}} iex&gt; {:error, :foo} |&gt; GenAI.Helpers.on_error(:label, :wrap) {:error, {:wrap, :foo}}","ref":"GenAI.Helpers.html#on_error/3"},{"type":"function","title":"GenAI.Helpers.on_nil/3","doc":"Handle {:ok, nil} tuple response. ## Examples iex&gt; { :ok , 5 } |&gt; GenAI.Helpers . on_nil ( :label , :unexpected ) { :ok , 5 } iex&gt; { :ok , nil } |&gt; GenAI.Helpers . on_nil ( :return_value , :bar ) { :ok , :bar } iex&gt; { :ok , nil } |&gt; GenAI.Helpers . on_nil ( :return_error , :bar ) { :error , :bar } iex&gt; { :ok , nil } |&gt; GenAI.Helpers . on_nil ( :return , :bar ) :bar iex&gt; { :ok , nil } |&gt; GenAI.Helpers . on_nil ( :call , fn -&gt; :biz end ) :biz iex&gt; { :ok , nil } |&gt; GenAI.Helpers . on_nil ( :label , :wrap ) { :error , { :wrap , :is_nil } } iex&gt; { :error , :foo } |&gt; GenAI.Helpers . on_nil ( :label , :wrap ) { :error , :foo }","ref":"GenAI.Helpers.html#on_nil/3"},{"type":"macro","title":"GenAI.Helpers.with_label/2","doc":"label block response Examples OK Response iex&gt; require GenAI.Helpers iex&gt; GenAI.Helpers . with_label ( :foo ) do iex&gt; { :ok , :bar } iex&gt; end { :foo , :bar } Error Response iex&gt; require GenAI.Helpers iex&gt; GenAI.Helpers . with_label ( :foo ) do iex&gt; { :error , :bar } iex&gt; end { :error , { :foo , :bar } } Non Tuple Response iex&gt; require GenAI.Helpers iex&gt; GenAI.Helpers . with_label ( :foo ) do iex&gt; :bop iex&gt; end { :foo , :bop }","ref":"GenAI.Helpers.html#with_label/2"},{"type":"module","title":"GenAI.InferenceProvider.DefaultProvider","doc":"Inference Provider Default Provider.","ref":"GenAI.InferenceProvider.DefaultProvider.html"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.chat/4","doc":"Sends a chat completion request to the Mistral API. This function constructs the request body based on the provided messages, tools, and settings, sends the request to the Mistral API, and returns a GenAI.ChatCompletion struct with the response.","ref":"GenAI.InferenceProvider.DefaultProvider.html#chat/4"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.chat/8","doc":"Low level inference, pass in model, messages, tools, and various settings to prepare final provider specific API requires.","ref":"GenAI.InferenceProvider.DefaultProvider.html#chat/8"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.do_chat/4","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#do_chat/4"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.do_chat/8","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#do_chat/8"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.do_effective_settings/5","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#do_effective_settings/5"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.do_endpoint/6","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#do_endpoint/6"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.do_headers/6","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#do_headers/6"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.do_request_body/8","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#do_request_body/8"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.do_run/4","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#do_run/4"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.effective_settings/5","doc":"Obtain map of effective settings: settings, model_settings, provider_settings, config_settings, etc.","ref":"GenAI.InferenceProvider.DefaultProvider.html#effective_settings/5"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.endpoint/6","doc":"Prepare endpoint and method to make inference call to","ref":"GenAI.InferenceProvider.DefaultProvider.html#endpoint/6"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.headers/2","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#headers/2"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.headers/6","doc":"Prepare request headers","ref":"GenAI.InferenceProvider.DefaultProvider.html#headers/6"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.request_body/8","doc":"Prepare request body to be passed to inference call.","ref":"GenAI.InferenceProvider.DefaultProvider.html#request_body/8"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.run/4","doc":"Run inference and return completion response and updated session","ref":"GenAI.InferenceProvider.DefaultProvider.html#run/4"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.standardize_model/1","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#standardize_model/1"},{"type":"function","title":"GenAI.InferenceProvider.DefaultProvider.standardize_model/3","doc":"","ref":"GenAI.InferenceProvider.DefaultProvider.html#standardize_model/3"},{"type":"module","title":"GenAI.InferenceProvider.Helpers","doc":"Inference Provider Helpers.","ref":"GenAI.InferenceProvider.Helpers.html"},{"type":"function","title":"GenAI.InferenceProvider.Helpers.api_call/5","doc":"Make API Call Via Finch.","ref":"GenAI.InferenceProvider.Helpers.html#api_call/5"},{"type":"function","title":"GenAI.InferenceProvider.Helpers.optional_field/3","doc":"Set optional field if present.","ref":"GenAI.InferenceProvider.Helpers.html#optional_field/3"},{"type":"function","title":"GenAI.InferenceProvider.Helpers.with_required_setting/3","doc":"Set required setting or raise RequestError if not present.","ref":"GenAI.InferenceProvider.Helpers.html#with_required_setting/3"},{"type":"function","title":"GenAI.InferenceProvider.Helpers.with_setting/4","doc":"Apply setting or default value if not present.","ref":"GenAI.InferenceProvider.Helpers.html#with_setting/4"},{"type":"function","title":"GenAI.InferenceProvider.Helpers.with_setting_as/5","doc":"Apply setting as_setting or default value if not present.","ref":"GenAI.InferenceProvider.Helpers.html#with_setting_as/5"},{"type":"behaviour","title":"GenAI.InferenceProviderBehaviour","doc":"","ref":"GenAI.InferenceProviderBehaviour.html"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.chat/7","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#c:chat/7"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.config_key/0","doc":"Return config_key inference provide application config stored under :genai entry","ref":"GenAI.InferenceProviderBehaviour.html#c:config_key/0"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.effective_settings/4","doc":"Obtain map of effective settings: settings, model_settings, provider_settings, config_settings, etc.","ref":"GenAI.InferenceProviderBehaviour.html#c:effective_settings/4"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.endpoint/5","doc":"Prepare endpoint and method to make inference call to","ref":"GenAI.InferenceProviderBehaviour.html#c:endpoint/5"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.headers/5","doc":"Prepare request headers","ref":"GenAI.InferenceProviderBehaviour.html#c:headers/5"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.request_body/7","doc":"Prepare request body to be passed to inference call.","ref":"GenAI.InferenceProviderBehaviour.html#c:request_body/7"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.run/3","doc":"Build and run inference thread","ref":"GenAI.InferenceProviderBehaviour.html#c:run/3"},{"type":"callback","title":"GenAI.InferenceProviderBehaviour.standardize_model/1","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#c:standardize_model/1"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.completion/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:completion/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.context/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:context/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.headers/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:headers/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.messages/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:messages/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.method/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:method/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.model/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:model/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.options/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:options/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.request_body/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:request_body/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.session/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:session/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.settings/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:settings/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.tools/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:tools/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.uri/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:uri/0"},{"type":"type","title":"GenAI.InferenceProviderBehaviour.url/0","doc":"","ref":"GenAI.InferenceProviderBehaviour.html#t:url/0"},{"type":"protocol","title":"GenAI.Legacy.NodeProtocol","doc":"","ref":"GenAI.Legacy.NodeProtocol.html"},{"type":"function","title":"GenAI.Legacy.NodeProtocol.apply/2","doc":"","ref":"GenAI.Legacy.NodeProtocol.html#apply/2"},{"type":"type","title":"GenAI.Legacy.NodeProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.Legacy.NodeProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Message","doc":"GenAI.Message is now a unified message structure. It's contents may include tool calls, results, images, audio, text blurbs, etc. Depending on compatibility with providers a universal GenAI.Message may need to be converted into a sequence of messages or altered in other ways. A message with tool calls for example would need to be converted into a tool call format for openai","ref":"GenAI.Message.html"},{"type":"function","title":"GenAI.Message.apply_node_directives/6","doc":"","ref":"GenAI.Message.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Message.assistant/2","doc":"","ref":"GenAI.Message.html#assistant/2"},{"type":"function","title":"GenAI.Message.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Message.html#description/1"},{"type":"function","title":"GenAI.Message.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Message.html#description/2"},{"type":"function","title":"GenAI.Message.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Message.html#handle/1"},{"type":"function","title":"GenAI.Message.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Message.html#handle/2"},{"type":"function","title":"GenAI.Message.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Message.html#id/1"},{"type":"function","title":"GenAI.Message.image/2","doc":"Load image resource.","ref":"GenAI.Message.html#image/2"},{"type":"function","title":"GenAI.Message.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Message.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Message.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Message.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Message.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Message.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Message.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Message.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Message.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Message.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Message.message/3","doc":"","ref":"GenAI.Message.html#message/3"},{"type":"function","title":"GenAI.Message.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Message.html#name/1"},{"type":"function","title":"GenAI.Message.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Message.html#name/2"},{"type":"function","title":"GenAI.Message.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Message.html#new/1"},{"type":"function","title":"GenAI.Message.system/2","doc":"","ref":"GenAI.Message.html#system/2"},{"type":"function","title":"GenAI.Message.user/2","doc":"","ref":"GenAI.Message.html#user/2"},{"type":"type","title":"GenAI.Message.t/0","doc":"","ref":"GenAI.Message.html#t:t/0"},{"type":"module","title":"GenAI.Message.Content.AudioContent","doc":"Represents image part of chat message.","ref":"GenAI.Message.Content.AudioContent.html"},{"type":"function","title":"GenAI.Message.Content.AudioContent.audio_length/1","doc":"Get image resolution.","ref":"GenAI.Message.Content.AudioContent.html#audio_length/1"},{"type":"function","title":"GenAI.Message.Content.AudioContent.base64/2","doc":"Base64 encode image content.","ref":"GenAI.Message.Content.AudioContent.html#base64/2"},{"type":"function","title":"GenAI.Message.Content.AudioContent.file_type/1","doc":"Get image type based on file extension.","ref":"GenAI.Message.Content.AudioContent.html#file_type/1"},{"type":"function","title":"GenAI.Message.Content.AudioContent.new/2","doc":"Prepare new image message content item.","ref":"GenAI.Message.Content.AudioContent.html#new/2"},{"type":"module","title":"GenAI.Message.Content.Document","doc":"","ref":"GenAI.Message.Content.Document.html"},{"type":"function","title":"GenAI.Message.Content.Document.new/1","doc":"","ref":"GenAI.Message.Content.Document.html#new/1"},{"type":"module","title":"GenAI.Message.Content.ImageContent","doc":"Represents image part of chat message.","ref":"GenAI.Message.Content.ImageContent.html"},{"type":"function","title":"GenAI.Message.Content.ImageContent.base64/2","doc":"Base64 encode image content.","ref":"GenAI.Message.Content.ImageContent.html#base64/2"},{"type":"function","title":"GenAI.Message.Content.ImageContent.file_type/1","doc":"Get image type based on file extension.","ref":"GenAI.Message.Content.ImageContent.html#file_type/1"},{"type":"function","title":"GenAI.Message.Content.ImageContent.new/2","doc":"Prepare new image message content item.","ref":"GenAI.Message.Content.ImageContent.html#new/2"},{"type":"function","title":"GenAI.Message.Content.ImageContent.resolution/1","doc":"Get image resolution.","ref":"GenAI.Message.Content.ImageContent.html#resolution/1"},{"type":"module","title":"GenAI.Message.Content.RedactedThinkingContent","doc":"Represents image part of chat message.","ref":"GenAI.Message.Content.RedactedThinkingContent.html"},{"type":"module","title":"GenAI.Message.Content.TextContent","doc":"Represents image part of chat message.","ref":"GenAI.Message.Content.TextContent.html"},{"type":"function","title":"GenAI.Message.Content.TextContent.new/1","doc":"","ref":"GenAI.Message.Content.TextContent.html#new/1"},{"type":"module","title":"GenAI.Message.Content.ThinkingContent","doc":"Represents image part of chat message.","ref":"GenAI.Message.Content.ThinkingContent.html"},{"type":"module","title":"GenAI.Message.Content.ToolResultContent","doc":"Represents image part of chat message.","ref":"GenAI.Message.Content.ToolResultContent.html"},{"type":"function","title":"GenAI.Message.Content.ToolResultContent.new/1","doc":"","ref":"GenAI.Message.Content.ToolResultContent.html#new/1"},{"type":"module","title":"GenAI.Message.Content.ToolUseContent","doc":"Represents image part of chat message.","ref":"GenAI.Message.Content.ToolUseContent.html"},{"type":"function","title":"GenAI.Message.Content.ToolUseContent.new/1","doc":"","ref":"GenAI.Message.Content.ToolUseContent.html#new/1"},{"type":"protocol","title":"GenAI.Message.ContentProtocol","doc":"A protocol for handling different types of content in messages.","ref":"GenAI.Message.ContentProtocol.html"},{"type":"function","title":"GenAI.Message.ContentProtocol.content/1","doc":"Return content of a message component.","ref":"GenAI.Message.ContentProtocol.html#content/1"},{"type":"type","title":"GenAI.Message.ContentProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.Message.ContentProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Message.ToolCall","doc":"","ref":"GenAI.Message.ToolCall.html"},{"type":"function","title":"GenAI.Message.ToolCall.to_json/2","doc":"","ref":"GenAI.Message.ToolCall.html#to_json/2"},{"type":"module","title":"GenAI.Message.ToolResponse","doc":"Represents a tool response in a message thread.","ref":"GenAI.Message.ToolResponse.html"},{"type":"function","title":"GenAI.Message.ToolResponse.apply_node_directives/6","doc":"","ref":"GenAI.Message.ToolResponse.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Message.ToolResponse.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Message.ToolResponse.html#description/1"},{"type":"function","title":"GenAI.Message.ToolResponse.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Message.ToolResponse.html#description/2"},{"type":"function","title":"GenAI.Message.ToolResponse.do_node_type/1","doc":"","ref":"GenAI.Message.ToolResponse.html#do_node_type/1"},{"type":"function","title":"GenAI.Message.ToolResponse.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Message.ToolResponse.html#handle/1"},{"type":"function","title":"GenAI.Message.ToolResponse.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Message.ToolResponse.html#handle/2"},{"type":"function","title":"GenAI.Message.ToolResponse.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Message.ToolResponse.html#id/1"},{"type":"function","title":"GenAI.Message.ToolResponse.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Message.ToolResponse.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Message.ToolResponse.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Message.ToolResponse.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Message.ToolResponse.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Message.ToolResponse.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Message.ToolResponse.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Message.ToolResponse.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Message.ToolResponse.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Message.ToolResponse.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Message.ToolResponse.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Message.ToolResponse.html#name/1"},{"type":"function","title":"GenAI.Message.ToolResponse.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Message.ToolResponse.html#name/2"},{"type":"function","title":"GenAI.Message.ToolResponse.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Message.ToolResponse.html#new/1"},{"type":"type","title":"GenAI.Message.ToolResponse.t/0","doc":"","ref":"GenAI.Message.ToolResponse.html#t:t/0"},{"type":"module","title":"GenAI.Message.ToolUsage","doc":"Represents a tool call in a message thread.","ref":"GenAI.Message.ToolUsage.html"},{"type":"function","title":"GenAI.Message.ToolUsage.apply_node_directives/6","doc":"","ref":"GenAI.Message.ToolUsage.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Message.ToolUsage.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Message.ToolUsage.html#description/1"},{"type":"function","title":"GenAI.Message.ToolUsage.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Message.ToolUsage.html#description/2"},{"type":"function","title":"GenAI.Message.ToolUsage.do_node_type/1","doc":"","ref":"GenAI.Message.ToolUsage.html#do_node_type/1"},{"type":"function","title":"GenAI.Message.ToolUsage.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Message.ToolUsage.html#handle/1"},{"type":"function","title":"GenAI.Message.ToolUsage.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Message.ToolUsage.html#handle/2"},{"type":"function","title":"GenAI.Message.ToolUsage.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Message.ToolUsage.html#id/1"},{"type":"function","title":"GenAI.Message.ToolUsage.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Message.ToolUsage.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Message.ToolUsage.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Message.ToolUsage.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Message.ToolUsage.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Message.ToolUsage.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Message.ToolUsage.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Message.ToolUsage.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Message.ToolUsage.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Message.ToolUsage.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Message.ToolUsage.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Message.ToolUsage.html#name/1"},{"type":"function","title":"GenAI.Message.ToolUsage.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Message.ToolUsage.html#name/2"},{"type":"function","title":"GenAI.Message.ToolUsage.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Message.ToolUsage.html#new/1"},{"type":"type","title":"GenAI.Message.ToolUsage.t/0","doc":"","ref":"GenAI.Message.ToolUsage.html#t:t/0"},{"type":"protocol","title":"GenAI.MessageProtocol","doc":"","ref":"GenAI.MessageProtocol.html"},{"type":"function","title":"GenAI.MessageProtocol.content/1","doc":"","ref":"GenAI.MessageProtocol.html#content/1"},{"type":"function","title":"GenAI.MessageProtocol.message/1","doc":"","ref":"GenAI.MessageProtocol.html#message/1"},{"type":"type","title":"GenAI.MessageProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.MessageProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Model","doc":"Represents a Provider Model plus picker details and encoder.","ref":"GenAI.Model.html"},{"type":"function","title":"GenAI.Model.apply_node_directives/6","doc":"","ref":"GenAI.Model.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Model.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Model.html#description/1"},{"type":"function","title":"GenAI.Model.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Model.html#description/2"},{"type":"function","title":"GenAI.Model.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Model.html#handle/1"},{"type":"function","title":"GenAI.Model.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Model.html#handle/2"},{"type":"function","title":"GenAI.Model.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Model.html#id/1"},{"type":"function","title":"GenAI.Model.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Model.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Model.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Model.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Model.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Model.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Model.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Model.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Model.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Model.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Model.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Model.html#name/1"},{"type":"function","title":"GenAI.Model.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Model.html#name/2"},{"type":"function","title":"GenAI.Model.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Model.html#new/1"},{"type":"type","title":"GenAI.Model.t/0","doc":"","ref":"GenAI.Model.html#t:t/0"},{"type":"module","title":"GenAI.Model.Encoder.DefaultProvider","doc":"","ref":"GenAI.Model.Encoder.DefaultProvider.html"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.apply_hyper_params_and_adjust/5","doc":"","ref":"GenAI.Model.Encoder.DefaultProvider.html#apply_hyper_params_and_adjust/5"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.completion_choice/8","doc":"","ref":"GenAI.Model.Encoder.DefaultProvider.html#completion_choice/8"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.completion_choices/8","doc":"","ref":"GenAI.Model.Encoder.DefaultProvider.html#completion_choices/8"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.completion_response/7","doc":"","ref":"GenAI.Model.Encoder.DefaultProvider.html#completion_response/7"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.default_hyper_params/6","doc":"Obtain list of hyper params supported by given model including mapping and conditional rules/alterations","ref":"GenAI.Model.Encoder.DefaultProvider.html#default_hyper_params/6"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.encode_message/6","doc":"Format message for provider/model type.","ref":"GenAI.Model.Encoder.DefaultProvider.html#encode_message/6"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.encode_tool/6","doc":"Format tool for provider/model type.","ref":"GenAI.Model.Encoder.DefaultProvider.html#encode_tool/6"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.headers/6","doc":"Prepare request headers","ref":"GenAI.Model.Encoder.DefaultProvider.html#headers/6"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.hyper_params/6","doc":"Obtain list of hyper params supported by given model including mapping and conditional rules/alterations","ref":"GenAI.Model.Encoder.DefaultProvider.html#hyper_params/6"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.normalize_messages/6","doc":"","ref":"GenAI.Model.Encoder.DefaultProvider.html#normalize_messages/6"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.request_body/8","doc":"Prepare request body to be passed to inference call.","ref":"GenAI.Model.Encoder.DefaultProvider.html#request_body/8"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.with_dynamic_setting/6","doc":"Set setting with dynamic model based logic.","ref":"GenAI.Model.Encoder.DefaultProvider.html#with_dynamic_setting/6"},{"type":"function","title":"GenAI.Model.Encoder.DefaultProvider.with_dynamic_setting_as/7","doc":"Set setting as_setting with dynamic model based logic.","ref":"GenAI.Model.Encoder.DefaultProvider.html#with_dynamic_setting_as/7"},{"type":"behaviour","title":"GenAI.Model.EncoderBehaviour","doc":"","ref":"GenAI.Model.EncoderBehaviour.html"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.completion_response/6","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#c:completion_response/6"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.default_hyper_params/5","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#c:default_hyper_params/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.encode_message/5","doc":"Format message for provider/model type.","ref":"GenAI.Model.EncoderBehaviour.html#c:encode_message/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.encode_tool/5","doc":"Format tool for provider/model type.","ref":"GenAI.Model.EncoderBehaviour.html#c:encode_tool/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.endpoint/5","doc":"Prepare endpoint and method to make inference call to","ref":"GenAI.Model.EncoderBehaviour.html#c:endpoint/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.headers/5","doc":"Prepare request headers","ref":"GenAI.Model.EncoderBehaviour.html#c:headers/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.hyper_params/5","doc":"Obtain list of hyper params supported by given model including mapping and conditional rules/alterations","ref":"GenAI.Model.EncoderBehaviour.html#c:hyper_params/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.normalize_messages/5","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#c:normalize_messages/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.request_body/7","doc":"Prepare request body to be passed to inference call.","ref":"GenAI.Model.EncoderBehaviour.html#c:request_body/7"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.with_dynamic_setting/4","doc":"Set setting with dynamic model based logic.","ref":"GenAI.Model.EncoderBehaviour.html#c:with_dynamic_setting/4"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.with_dynamic_setting/5","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#c:with_dynamic_setting/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.with_dynamic_setting_as/5","doc":"Set setting as_setting with dynamic model based logic.","ref":"GenAI.Model.EncoderBehaviour.html#c:with_dynamic_setting_as/5"},{"type":"callback","title":"GenAI.Model.EncoderBehaviour.with_dynamic_setting_as/6","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#c:with_dynamic_setting_as/6"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.completion/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:completion/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.context/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:context/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.headers/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:headers/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.json/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:json/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.message/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:message/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.messages/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:messages/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.method/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:method/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.model/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:model/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.options/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:options/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.request_body/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:request_body/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.session/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:session/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.settings/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:settings/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.tool/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:tool/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.tools/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:tools/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.uri/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:uri/0"},{"type":"type","title":"GenAI.Model.EncoderBehaviour.url/0","doc":"","ref":"GenAI.Model.EncoderBehaviour.html#t:url/0"},{"type":"module","title":"GenAI.ModelDetail.BenchMarks","doc":"Last reported model evaluation benchmark scores.","ref":"GenAI.ModelDetail.BenchMarks.html"},{"type":"type","title":"GenAI.ModelDetail.BenchMarks.t/0","doc":"","ref":"GenAI.ModelDetail.BenchMarks.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.Capacity","doc":"Provides standardized structure for tracking capacity details. requests per minute tokens per minute tokens per day inference_speed vram","ref":"GenAI.ModelDetail.Capacity.html"},{"type":"type","title":"GenAI.ModelDetail.Capacity.t/0","doc":"","ref":"GenAI.ModelDetail.Capacity.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.Costing","doc":"Provides standardized structure for tracking costing details. cost per million input tokens cost per million output tokens cost per hour cost per request media costs","ref":"GenAI.ModelDetail.Costing.html"},{"type":"type","title":"GenAI.ModelDetail.Costing.t/0","doc":"","ref":"GenAI.ModelDetail.Costing.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.FineTuning","doc":"Tracks fine tuning details for the model, if any. Type of fine tuning Fine Tuning Date Fine Tuning Notes","ref":"GenAI.ModelDetail.FineTuning.html"},{"type":"type","title":"GenAI.ModelDetail.FineTuning.t/0","doc":"","ref":"GenAI.ModelDetail.FineTuning.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.HyperParamSupport","doc":"Provides standardized structure for tracking hyper parameter support such as allowed values, ranges, mapping etc.","ref":"GenAI.ModelDetail.HyperParamSupport.html"},{"type":"type","title":"GenAI.ModelDetail.HyperParamSupport.t/0","doc":"","ref":"GenAI.ModelDetail.HyperParamSupport.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.ModalitySupport","doc":"Provides standardized structure for tracking modality support details. For example if a model can mimic video support by streaming images, plus audio transcription. Or supports native image and audio.","ref":"GenAI.ModelDetail.ModalitySupport.html"},{"type":"type","title":"GenAI.ModelDetail.ModalitySupport.t/0","doc":"","ref":"GenAI.ModelDetail.ModalitySupport.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.ToolUsage","doc":"Provides details on tool usage support: native (api level), prompt injection, no support, etc.","ref":"GenAI.ModelDetail.ToolUsage.html"},{"type":"type","title":"GenAI.ModelDetail.ToolUsage.t/0","doc":"","ref":"GenAI.ModelDetail.ToolUsage.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.TrainingDetails","doc":"Provides standardized structure for tracking training details such as training cut off, supplemental_training per subject cut offs, etc. censorship. instruct training, dolphin, etc.","ref":"GenAI.ModelDetail.TrainingDetails.html"},{"type":"type","title":"GenAI.ModelDetail.TrainingDetails.t/0","doc":"","ref":"GenAI.ModelDetail.TrainingDetails.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetail.UseCaseSupport","doc":"Provides standardized structure for tracking use case support details. Where use case is the ability of the model to perform a task like feature extraction, generating synthetic memories, etc. Tracks both per model fixed scores plus dynamic adjustments based on system/user feedback.","ref":"GenAI.ModelDetail.UseCaseSupport.html"},{"type":"type","title":"GenAI.ModelDetail.UseCaseSupport.t/0","doc":"","ref":"GenAI.ModelDetail.UseCaseSupport.html#t:t/0"},{"type":"module","title":"GenAI.ModelDetails","doc":"Provides standardized structure for tracking extended module details.","ref":"GenAI.ModelDetails.html"},{"type":"type","title":"GenAI.ModelDetails.benchmarks/0","doc":"","ref":"GenAI.ModelDetails.html#t:benchmarks/0"},{"type":"type","title":"GenAI.ModelDetails.capacity/0","doc":"","ref":"GenAI.ModelDetails.html#t:capacity/0"},{"type":"type","title":"GenAI.ModelDetails.costing/0","doc":"","ref":"GenAI.ModelDetails.html#t:costing/0"},{"type":"type","title":"GenAI.ModelDetails.fine_tuning/0","doc":"","ref":"GenAI.ModelDetails.html#t:fine_tuning/0"},{"type":"type","title":"GenAI.ModelDetails.hyper_param_support/0","doc":"","ref":"GenAI.ModelDetails.html#t:hyper_param_support/0"},{"type":"type","title":"GenAI.ModelDetails.modalities/0","doc":"","ref":"GenAI.ModelDetails.html#t:modalities/0"},{"type":"type","title":"GenAI.ModelDetails.release_status/0","doc":"","ref":"GenAI.ModelDetails.html#t:release_status/0"},{"type":"type","title":"GenAI.ModelDetails.support_status/0","doc":"","ref":"GenAI.ModelDetails.html#t:support_status/0"},{"type":"type","title":"GenAI.ModelDetails.t/0","doc":"","ref":"GenAI.ModelDetails.html#t:t/0"},{"type":"type","title":"GenAI.ModelDetails.tool_usage/0","doc":"","ref":"GenAI.ModelDetails.html#t:tool_usage/0"},{"type":"type","title":"GenAI.ModelDetails.training_details/0","doc":"","ref":"GenAI.ModelDetails.html#t:training_details/0"},{"type":"type","title":"GenAI.ModelDetails.use_case_support/0","doc":"","ref":"GenAI.ModelDetails.html#t:use_case_support/0"},{"type":"module","title":"GenAI.ModelMetadata.DefaultProvider","doc":"","ref":"GenAI.ModelMetadata.DefaultProvider.html"},{"type":"function","title":"GenAI.ModelMetadata.DefaultProvider.get/3","doc":"","ref":"GenAI.ModelMetadata.DefaultProvider.html#get/3"},{"type":"behaviour","title":"GenAI.ModelMetadata.ProviderBehaviour","doc":"","ref":"GenAI.ModelMetadata.ProviderBehaviour.html"},{"type":"callback","title":"GenAI.ModelMetadata.ProviderBehaviour.get/2","doc":"","ref":"GenAI.ModelMetadata.ProviderBehaviour.html#c:get/2"},{"type":"function","title":"GenAI.ModelMetadata.ProviderBehaviour.get/3","doc":"","ref":"GenAI.ModelMetadata.ProviderBehaviour.html#get/3"},{"type":"callback","title":"GenAI.ModelMetadata.ProviderBehaviour.get/3","doc":"","ref":"GenAI.ModelMetadata.ProviderBehaviour.html#c:get/3"},{"type":"function","title":"GenAI.ModelMetadata.ProviderBehaviour.get/4","doc":"","ref":"GenAI.ModelMetadata.ProviderBehaviour.html#get/4"},{"type":"protocol","title":"GenAI.ModelProtocol","doc":"","ref":"GenAI.ModelProtocol.html"},{"type":"function","title":"GenAI.ModelProtocol.encoder/1","doc":"","ref":"GenAI.ModelProtocol.html#encoder/1"},{"type":"function","title":"GenAI.ModelProtocol.handle/1","doc":"","ref":"GenAI.ModelProtocol.html#handle/1"},{"type":"function","title":"GenAI.ModelProtocol.name/1","doc":"","ref":"GenAI.ModelProtocol.html#name/1"},{"type":"function","title":"GenAI.ModelProtocol.provider/1","doc":"","ref":"GenAI.ModelProtocol.html#provider/1"},{"type":"function","title":"GenAI.ModelProtocol.register/2","doc":"","ref":"GenAI.ModelProtocol.html#register/2"},{"type":"type","title":"GenAI.ModelProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.ModelProtocol.html#t:t/0"},{"type":"behaviour","title":"GenAI.Provider.ModelsBehaviour","doc":"","ref":"GenAI.Provider.ModelsBehaviour.html"},{"type":"callback","title":"GenAI.Provider.ModelsBehaviour.load_metadata/1","doc":"","ref":"GenAI.Provider.ModelsBehaviour.html#c:load_metadata/1"},{"type":"function","title":"GenAI.Provider.ModelsBehaviour.load_metadata/2","doc":"","ref":"GenAI.Provider.ModelsBehaviour.html#load_metadata/2"},{"type":"module","title":"GenAI.Records.Directive","doc":"Records used by for directive processing.","ref":"GenAI.Records.Directive.html"},{"type":"macro","title":"GenAI.Records.Directive.concrete_value/1","doc":"","ref":"GenAI.Records.Directive.html#concrete_value/1"},{"type":"macro","title":"GenAI.Records.Directive.concrete_value/2","doc":"","ref":"GenAI.Records.Directive.html#concrete_value/2"},{"type":"macro","title":"GenAI.Records.Directive.data_generator_entry/1","doc":"","ref":"GenAI.Records.Directive.html#data_generator_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.data_generator_entry/2","doc":"","ref":"GenAI.Records.Directive.html#data_generator_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.hyper_param/1","doc":"","ref":"GenAI.Records.Directive.html#hyper_param/1"},{"type":"macro","title":"GenAI.Records.Directive.hyper_param/2","doc":"","ref":"GenAI.Records.Directive.html#hyper_param/2"},{"type":"macro","title":"GenAI.Records.Directive.message_entry/1","doc":"","ref":"GenAI.Records.Directive.html#message_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.message_entry/2","doc":"","ref":"GenAI.Records.Directive.html#message_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.model_entry/1","doc":"","ref":"GenAI.Records.Directive.html#model_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.model_entry/2","doc":"","ref":"GenAI.Records.Directive.html#model_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.model_setting_entry/1","doc":"","ref":"GenAI.Records.Directive.html#model_setting_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.model_setting_entry/2","doc":"","ref":"GenAI.Records.Directive.html#model_setting_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.monitor_entry/1","doc":"","ref":"GenAI.Records.Directive.html#monitor_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.monitor_entry/2","doc":"","ref":"GenAI.Records.Directive.html#monitor_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.option_entry/1","doc":"","ref":"GenAI.Records.Directive.html#option_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.option_entry/2","doc":"","ref":"GenAI.Records.Directive.html#option_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.provider_setting_entry/1","doc":"","ref":"GenAI.Records.Directive.html#provider_setting_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.provider_setting_entry/2","doc":"","ref":"GenAI.Records.Directive.html#provider_setting_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.safety_setting_entry/1","doc":"","ref":"GenAI.Records.Directive.html#safety_setting_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.safety_setting_entry/2","doc":"","ref":"GenAI.Records.Directive.html#safety_setting_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.setting_entry/1","doc":"","ref":"GenAI.Records.Directive.html#setting_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.setting_entry/2","doc":"","ref":"GenAI.Records.Directive.html#setting_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.stack_entry/1","doc":"","ref":"GenAI.Records.Directive.html#stack_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.stack_entry/2","doc":"","ref":"GenAI.Records.Directive.html#stack_entry/2"},{"type":"macro","title":"GenAI.Records.Directive.tool_entry/1","doc":"","ref":"GenAI.Records.Directive.html#tool_entry/1"},{"type":"macro","title":"GenAI.Records.Directive.tool_entry/2","doc":"","ref":"GenAI.Records.Directive.html#tool_entry/2"},{"type":"type","title":"GenAI.Records.Directive.adjuster/0","doc":"Optional lambda method to adjust setting value before setting in inference request.","ref":"GenAI.Records.Directive.html#t:adjuster/0"},{"type":"type","title":"GenAI.Records.Directive.as/0","doc":"alias to inject param as when building model request.","ref":"GenAI.Records.Directive.html#t:as/0"},{"type":"type","title":"GenAI.Records.Directive.concrete_value/0","doc":"Concrete Entry Value.","ref":"GenAI.Records.Directive.html#t:concrete_value/0"},{"type":"type","title":"GenAI.Records.Directive.data_generator_entry/0","doc":"Reference to a data generator entry.","ref":"GenAI.Records.Directive.html#t:data_generator_entry/0"},{"type":"type","title":"GenAI.Records.Directive.default/0","doc":"Default value is only used for required settings if not provided.","ref":"GenAI.Records.Directive.html#t:default/0"},{"type":"type","title":"GenAI.Records.Directive.hyper_param/0","doc":"Supported Parameter Record.","ref":"GenAI.Records.Directive.html#t:hyper_param/0"},{"type":"type","title":"GenAI.Records.Directive.message_entry/0","doc":"Reference to a message list.","ref":"GenAI.Records.Directive.html#t:message_entry/0"},{"type":"type","title":"GenAI.Records.Directive.model_entry/0","doc":"Reference to a model entry.","ref":"GenAI.Records.Directive.html#t:model_entry/0"},{"type":"type","title":"GenAI.Records.Directive.model_setting_entry/0","doc":"Reference to a model-specific setting entry.","ref":"GenAI.Records.Directive.html#t:model_setting_entry/0"},{"type":"type","title":"GenAI.Records.Directive.monitor_entry/0","doc":"Reference to a monitor entry.","ref":"GenAI.Records.Directive.html#t:monitor_entry/0"},{"type":"type","title":"GenAI.Records.Directive.option_entry/0","doc":"Reference to an option entry.","ref":"GenAI.Records.Directive.html#t:option_entry/0"},{"type":"type","title":"GenAI.Records.Directive.param/0","doc":"input key for param: value pulled from effective settings","ref":"GenAI.Records.Directive.html#t:param/0"},{"type":"type","title":"GenAI.Records.Directive.param_type/0","doc":"type of supported parm","ref":"GenAI.Records.Directive.html#t:param_type/0"},{"type":"type","title":"GenAI.Records.Directive.provider_setting_entry/0","doc":"Reference to a provider-specific setting entry.","ref":"GenAI.Records.Directive.html#t:provider_setting_entry/0"},{"type":"type","title":"GenAI.Records.Directive.range/0","doc":"allowed range of values for param","ref":"GenAI.Records.Directive.html#t:range/0"},{"type":"type","title":"GenAI.Records.Directive.required/0","doc":"flag if field is required","ref":"GenAI.Records.Directive.html#t:required/0"},{"type":"type","title":"GenAI.Records.Directive.safety_setting_entry/0","doc":"Reference to a safety setting entry.","ref":"GenAI.Records.Directive.html#t:safety_setting_entry/0"},{"type":"type","title":"GenAI.Records.Directive.sentinel/0","doc":"Optional lambda method to check (model, setting, settings, session, context, options) to determine if setting is valid/supported.","ref":"GenAI.Records.Directive.html#t:sentinel/0"},{"type":"type","title":"GenAI.Records.Directive.setting_entry/0","doc":"Reference to a setting entry.","ref":"GenAI.Records.Directive.html#t:setting_entry/0"},{"type":"type","title":"GenAI.Records.Directive.stack_entry/0","doc":"Reference to a stack entry.","ref":"GenAI.Records.Directive.html#t:stack_entry/0"},{"type":"type","title":"GenAI.Records.Directive.tool_entry/0","doc":"Reference to a tool entry.","ref":"GenAI.Records.Directive.html#t:tool_entry/0"},{"type":"module","title":"GenAI.Records.Link","doc":"Records related to graph links.","ref":"GenAI.Records.Link.html"},{"type":"macro","title":"GenAI.Records.Link.anchor_link/1","doc":"","ref":"GenAI.Records.Link.html#anchor_link/1"},{"type":"macro","title":"GenAI.Records.Link.anchor_link/2","doc":"","ref":"GenAI.Records.Link.html#anchor_link/2"},{"type":"macro","title":"GenAI.Records.Link.connector/1","doc":"","ref":"GenAI.Records.Link.html#connector/1"},{"type":"macro","title":"GenAI.Records.Link.connector/2","doc":"","ref":"GenAI.Records.Link.html#connector/2"},{"type":"macro","title":"GenAI.Records.Link.element_context/1","doc":"","ref":"GenAI.Records.Link.html#element_context/1"},{"type":"macro","title":"GenAI.Records.Link.element_context/2","doc":"","ref":"GenAI.Records.Link.html#element_context/2"},{"type":"macro","title":"GenAI.Records.Link.element_lookup/1","doc":"","ref":"GenAI.Records.Link.html#element_lookup/1"},{"type":"macro","title":"GenAI.Records.Link.element_lookup/2","doc":"","ref":"GenAI.Records.Link.html#element_lookup/2"},{"type":"macro","title":"GenAI.Records.Link.graph_handle/1","doc":"","ref":"GenAI.Records.Link.html#graph_handle/1"},{"type":"macro","title":"GenAI.Records.Link.graph_handle/2","doc":"","ref":"GenAI.Records.Link.html#graph_handle/2"},{"type":"type","title":"GenAI.Records.Link.anchor_link/0","doc":"Anchor Links point to a handle from the root node and from it's scope a nested local handle. Unlike the standard lookup logic only local handles are considered and we take the closest (first) local handle below the anchor. local_handle may itself be an array / path of local nodes below the anchor handle","ref":"GenAI.Records.Link.html#t:anchor_link/0"},{"type":"type","title":"GenAI.Records.Link.connector/0","doc":"Record representing a link connector (target, and socket). Note Socket is used for elements with special input output links like grid search to indicate appropriate link to use per state.","ref":"GenAI.Records.Link.html#t:connector/0"},{"type":"type","title":"GenAI.Records.Link.element_context/0","doc":"Record container a graph node, the link leading to the node and immeidate parent of the graph node.","ref":"GenAI.Records.Link.html#t:element_context/0"},{"type":"type","title":"GenAI.Records.Link.element_lookup/0","doc":"Element lookup entries point from the Graph Root to nested elements.","ref":"GenAI.Records.Link.html#t:element_lookup/0"},{"type":"type","title":"GenAI.Records.Link.graph_handle/0","doc":"A graph handle are used to reference a graph element by name Global scopes must be unique and can not be overridden locally. Standard scope must be unique but can be overridden by local scoped handles. When looking up handles we check for a global first, then a local, and if not local is in scope we check standard entries.","ref":"GenAI.Records.Link.html#t:graph_handle/0"},{"type":"module","title":"GenAI.Records.Node","doc":"Records used by for preparing/processing nodes.","ref":"GenAI.Records.Node.html"},{"type":"macro","title":"GenAI.Records.Node.process_end/1","doc":"","ref":"GenAI.Records.Node.html#process_end/1"},{"type":"macro","title":"GenAI.Records.Node.process_end/2","doc":"","ref":"GenAI.Records.Node.html#process_end/2"},{"type":"macro","title":"GenAI.Records.Node.process_error/1","doc":"","ref":"GenAI.Records.Node.html#process_error/1"},{"type":"macro","title":"GenAI.Records.Node.process_error/2","doc":"","ref":"GenAI.Records.Node.html#process_error/2"},{"type":"macro","title":"GenAI.Records.Node.process_next/1","doc":"","ref":"GenAI.Records.Node.html#process_next/1"},{"type":"macro","title":"GenAI.Records.Node.process_next/2","doc":"","ref":"GenAI.Records.Node.html#process_next/2"},{"type":"macro","title":"GenAI.Records.Node.process_yield/1","doc":"","ref":"GenAI.Records.Node.html#process_yield/1"},{"type":"macro","title":"GenAI.Records.Node.process_yield/2","doc":"","ref":"GenAI.Records.Node.html#process_yield/2"},{"type":"type","title":"GenAI.Records.Node.process_end/0","doc":"Indicate no further nodes to process.","ref":"GenAI.Records.Node.html#t:process_end/0"},{"type":"type","title":"GenAI.Records.Node.process_error/0","doc":"Processing error","ref":"GenAI.Records.Node.html#t:process_error/0"},{"type":"type","title":"GenAI.Records.Node.process_next/0","doc":"Indicate node to process next.","ref":"GenAI.Records.Node.html#t:process_next/0"},{"type":"type","title":"GenAI.Records.Node.process_yield/0","doc":"Yield processing for.","ref":"GenAI.Records.Node.html#t:process_yield/0"},{"type":"module","title":"GenAI.Session.Runtime","doc":"Tracks runtime/operating time state of session/thread.","ref":"GenAI.Session.Runtime.html"},{"type":"function","title":"GenAI.Session.Runtime.command/4","doc":"Apply specified command to runtime struct.","ref":"GenAI.Session.Runtime.html#command/4"},{"type":"function","title":"GenAI.Session.Runtime.new/1","doc":"Setup new Runtime struct.","ref":"GenAI.Session.Runtime.html#new/1"},{"type":"module","title":"GenAI.Session.State","doc":"Represent status/state such as node state, sessions, message thread, etc.","ref":"GenAI.Session.State.html"},{"type":"function","title":"GenAI.Session.State.entry_path/1","doc":"","ref":"GenAI.Session.State.html#entry_path/1"},{"type":"function","title":"GenAI.Session.State.initialize/4","doc":"","ref":"GenAI.Session.State.html#initialize/4"},{"type":"function","title":"GenAI.Session.State.monitor/4","doc":"","ref":"GenAI.Session.State.html#monitor/4"},{"type":"function","title":"GenAI.Session.State.new/1","doc":"","ref":"GenAI.Session.State.html#new/1"},{"type":"type","title":"GenAI.Session.State.t/0","doc":"","ref":"GenAI.Session.State.html#t:t/0"},{"type":"module","title":"GenAI.Session.State.Directive","doc":"Directive that is applied to build effective state.","ref":"GenAI.Session.State.Directive.html"},{"type":"function","title":"GenAI.Session.State.Directive.apply_directive/4","doc":"","ref":"GenAI.Session.State.Directive.html#apply_directive/4"},{"type":"function","title":"GenAI.Session.State.Directive.expired?/1","doc":"","ref":"GenAI.Session.State.Directive.html#expired?/1"},{"type":"function","title":"GenAI.Session.State.Directive.fingerprint/1","doc":"","ref":"GenAI.Session.State.Directive.html#fingerprint/1"},{"type":"function","title":"GenAI.Session.State.Directive.static/3","doc":"","ref":"GenAI.Session.State.Directive.html#static/3"},{"type":"module","title":"GenAI.Session.StateEntry","doc":"A entry (built by directives) in a session state struct.","ref":"GenAI.Session.StateEntry.html"},{"type":"function","title":"GenAI.Session.StateEntry.update_entry/4","doc":"","ref":"GenAI.Session.StateEntry.html#update_entry/4"},{"type":"module","title":"GenAI.Setting","doc":"A module representing a setting node in a graph structure. This module defines the structure and behavior of a setting node, including its identifier, setting, and value.","ref":"GenAI.Setting.html"},{"type":"function","title":"GenAI.Setting.apply_node_directives/6","doc":"","ref":"GenAI.Setting.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Setting.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Setting.html#description/1"},{"type":"function","title":"GenAI.Setting.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Setting.html#description/2"},{"type":"function","title":"GenAI.Setting.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Setting.html#handle/1"},{"type":"function","title":"GenAI.Setting.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Setting.html#handle/2"},{"type":"function","title":"GenAI.Setting.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Setting.html#id/1"},{"type":"function","title":"GenAI.Setting.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Setting.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Setting.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Setting.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Setting.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Setting.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Setting.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Setting.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Setting.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Setting.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Setting.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Setting.html#name/1"},{"type":"function","title":"GenAI.Setting.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Setting.html#name/2"},{"type":"function","title":"GenAI.Setting.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Setting.html#new/1"},{"type":"type","title":"GenAI.Setting.t/0","doc":"","ref":"GenAI.Setting.html#t:t/0"},{"type":"module","title":"GenAI.Setting.ModelSetting","doc":"Represents a Provider Setting (used by Gemini)","ref":"GenAI.Setting.ModelSetting.html"},{"type":"function","title":"GenAI.Setting.ModelSetting.apply_node_directives/6","doc":"","ref":"GenAI.Setting.ModelSetting.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Setting.ModelSetting.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Setting.ModelSetting.html#description/1"},{"type":"function","title":"GenAI.Setting.ModelSetting.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Setting.ModelSetting.html#description/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.do_node_type/1","doc":"","ref":"GenAI.Setting.ModelSetting.html#do_node_type/1"},{"type":"function","title":"GenAI.Setting.ModelSetting.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Setting.ModelSetting.html#handle/1"},{"type":"function","title":"GenAI.Setting.ModelSetting.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Setting.ModelSetting.html#handle/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Setting.ModelSetting.html#id/1"},{"type":"function","title":"GenAI.Setting.ModelSetting.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Setting.ModelSetting.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Setting.ModelSetting.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Setting.ModelSetting.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Setting.ModelSetting.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Setting.ModelSetting.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Setting.ModelSetting.html#name/1"},{"type":"function","title":"GenAI.Setting.ModelSetting.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Setting.ModelSetting.html#name/2"},{"type":"function","title":"GenAI.Setting.ModelSetting.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Setting.ModelSetting.html#new/1"},{"type":"type","title":"GenAI.Setting.ModelSetting.t/0","doc":"","ref":"GenAI.Setting.ModelSetting.html#t:t/0"},{"type":"module","title":"GenAI.Setting.ProviderSetting","doc":"Represents a Provider Setting (used by Gemini)","ref":"GenAI.Setting.ProviderSetting.html"},{"type":"function","title":"GenAI.Setting.ProviderSetting.apply_node_directives/6","doc":"","ref":"GenAI.Setting.ProviderSetting.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Setting.ProviderSetting.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Setting.ProviderSetting.html#description/1"},{"type":"function","title":"GenAI.Setting.ProviderSetting.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Setting.ProviderSetting.html#description/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.do_node_type/1","doc":"","ref":"GenAI.Setting.ProviderSetting.html#do_node_type/1"},{"type":"function","title":"GenAI.Setting.ProviderSetting.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Setting.ProviderSetting.html#handle/1"},{"type":"function","title":"GenAI.Setting.ProviderSetting.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Setting.ProviderSetting.html#handle/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Setting.ProviderSetting.html#id/1"},{"type":"function","title":"GenAI.Setting.ProviderSetting.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Setting.ProviderSetting.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Setting.ProviderSetting.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Setting.ProviderSetting.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Setting.ProviderSetting.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Setting.ProviderSetting.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Setting.ProviderSetting.html#name/1"},{"type":"function","title":"GenAI.Setting.ProviderSetting.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Setting.ProviderSetting.html#name/2"},{"type":"function","title":"GenAI.Setting.ProviderSetting.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Setting.ProviderSetting.html#new/1"},{"type":"type","title":"GenAI.Setting.ProviderSetting.t/0","doc":"","ref":"GenAI.Setting.ProviderSetting.html#t:t/0"},{"type":"module","title":"GenAI.Setting.SafetySetting","doc":"Represents a Model Safety Setting (used by Gemini)","ref":"GenAI.Setting.SafetySetting.html"},{"type":"function","title":"GenAI.Setting.SafetySetting.apply_node_directives/6","doc":"","ref":"GenAI.Setting.SafetySetting.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Setting.SafetySetting.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Setting.SafetySetting.html#description/1"},{"type":"function","title":"GenAI.Setting.SafetySetting.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Setting.SafetySetting.html#description/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.do_node_type/1","doc":"","ref":"GenAI.Setting.SafetySetting.html#do_node_type/1"},{"type":"function","title":"GenAI.Setting.SafetySetting.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Setting.SafetySetting.html#handle/1"},{"type":"function","title":"GenAI.Setting.SafetySetting.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Setting.SafetySetting.html#handle/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Setting.SafetySetting.html#id/1"},{"type":"function","title":"GenAI.Setting.SafetySetting.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Setting.SafetySetting.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Setting.SafetySetting.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Setting.SafetySetting.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Setting.SafetySetting.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Setting.SafetySetting.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Setting.SafetySetting.html#name/1"},{"type":"function","title":"GenAI.Setting.SafetySetting.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Setting.SafetySetting.html#name/2"},{"type":"function","title":"GenAI.Setting.SafetySetting.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Setting.SafetySetting.html#new/1"},{"type":"type","title":"GenAI.Setting.SafetySetting.t/0","doc":"","ref":"GenAI.Setting.SafetySetting.html#t:t/0"},{"type":"module","title":"GenAI.State.Directive","doc":"A state directive applies selection values for specified state entries","ref":"GenAI.State.Directive.html"},{"type":"module","title":"GenAI.State.Entry","doc":"A setting entry like model, provider, temperature set via directive.","ref":"GenAI.State.Entry.html"},{"type":"function","title":"GenAI.State.Entry.apply_selector/2","doc":"","ref":"GenAI.State.Entry.html#apply_selector/2"},{"type":"protocol","title":"GenAI.Thread.LegacyStateProtocol","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.apply_message/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#apply_message/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.apply_model/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#apply_model/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.apply_model_setting/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#apply_model_setting/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.apply_provider_setting/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#apply_provider_setting/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.apply_safety_setting/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#apply_safety_setting/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.apply_setting/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#apply_setting/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.apply_tool/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#apply_tool/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.effective_messages/4","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#effective_messages/4"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.effective_model/3","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#effective_model/3"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.effective_model_settings/4","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#effective_model_settings/4"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.effective_provider_settings/4","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#effective_provider_settings/4"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.effective_safety_settings/3","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#effective_safety_settings/3"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.effective_settings/3","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#effective_settings/3"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.effective_tools/4","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#effective_tools/4"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.get_artifact/2","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#get_artifact/2"},{"type":"function","title":"GenAI.Thread.LegacyStateProtocol.set_artifact/3","doc":"","ref":"GenAI.Thread.LegacyStateProtocol.html#set_artifact/3"},{"type":"type","title":"GenAI.Thread.LegacyStateProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.Thread.LegacyStateProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Thread.Session","doc":"More advanced VNext Thread Implementation","ref":"GenAI.Thread.Session.html"},{"type":"function","title":"GenAI.Thread.Session.append_directive/4","doc":"","ref":"GenAI.Thread.Session.html#append_directive/4"},{"type":"function","title":"GenAI.Thread.Session.apply_directives/3","doc":"","ref":"GenAI.Thread.Session.html#apply_directives/3"},{"type":"function","title":"GenAI.Thread.Session.new/1","doc":"","ref":"GenAI.Thread.Session.html#new/1"},{"type":"function","title":"GenAI.Thread.Session.pending_directives?/1","doc":"","ref":"GenAI.Thread.Session.html#pending_directives?/1"},{"type":"module","title":"GenAI.Thread.Standard","doc":"This module defines the chat struct used to manage conversations with generative AI models.","ref":"GenAI.Thread.Standard.html"},{"type":"function","title":"GenAI.Thread.Standard.new/1","doc":"","ref":"GenAI.Thread.Standard.html#new/1"},{"type":"module","title":"GenAI.Thread.State","doc":"","ref":"GenAI.Thread.State.html"},{"type":"protocol","title":"GenAI.ThreadProtocol","doc":"","ref":"GenAI.ThreadProtocol.html"},{"type":"function","title":"GenAI.ThreadProtocol.append_directive/4","doc":"","ref":"GenAI.ThreadProtocol.html#append_directive/4"},{"type":"function","title":"GenAI.ThreadProtocol.effective_messages/4","doc":"","ref":"GenAI.ThreadProtocol.html#effective_messages/4"},{"type":"function","title":"GenAI.ThreadProtocol.effective_model/3","doc":"","ref":"GenAI.ThreadProtocol.html#effective_model/3"},{"type":"function","title":"GenAI.ThreadProtocol.effective_model_settings/4","doc":"","ref":"GenAI.ThreadProtocol.html#effective_model_settings/4"},{"type":"function","title":"GenAI.ThreadProtocol.effective_provider_settings/4","doc":"","ref":"GenAI.ThreadProtocol.html#effective_provider_settings/4"},{"type":"function","title":"GenAI.ThreadProtocol.effective_safety_settings/3","doc":"","ref":"GenAI.ThreadProtocol.html#effective_safety_settings/3"},{"type":"function","title":"GenAI.ThreadProtocol.effective_settings/3","doc":"","ref":"GenAI.ThreadProtocol.html#effective_settings/3"},{"type":"function","title":"GenAI.ThreadProtocol.effective_tools/4","doc":"","ref":"GenAI.ThreadProtocol.html#effective_tools/4"},{"type":"function","title":"GenAI.ThreadProtocol.execute/4","doc":"","ref":"GenAI.ThreadProtocol.html#execute/4"},{"type":"function","title":"GenAI.ThreadProtocol.get_artifact/2","doc":"","ref":"GenAI.ThreadProtocol.html#get_artifact/2"},{"type":"function","title":"GenAI.ThreadProtocol.set_artifact/3","doc":"","ref":"GenAI.ThreadProtocol.html#set_artifact/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_api_key/3","doc":"Specify an API key for a provider.","ref":"GenAI.ThreadProtocol.html#with_api_key/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_api_org/3","doc":"Specify an API org for a provider.","ref":"GenAI.ThreadProtocol.html#with_api_org/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_message/3","doc":"Add a message to the conversation.","ref":"GenAI.ThreadProtocol.html#with_message/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_messages/3","doc":"Add a list of messages to the conversation.","ref":"GenAI.ThreadProtocol.html#with_messages/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_model/2","doc":"Specify a specific model or model picker. This function allows you to define the model to be used for inference. You can either provide a specific model, like Model.smartest() , or a model picker function that dynamically selects the best model based on the context and available providers. Examples: Model.smartest() - This will select the &quot;smartest&quot; available model at inference time, based on factors like performance and capabilities. Model.cheapest(params: :best_effort) - This will select the cheapest available model that can handle the given parameters and context size. CustomProvider.custom_model - This allows you to use a custom model from a user-defined provider.","ref":"GenAI.ThreadProtocol.html#with_model/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_model_setting/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_model_setting/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_model_setting/4","doc":"","ref":"GenAI.ThreadProtocol.html#with_model_setting/4"},{"type":"function","title":"GenAI.ThreadProtocol.with_model_settings/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_model_settings/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_model_settings/3","doc":"","ref":"GenAI.ThreadProtocol.html#with_model_settings/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_provider_setting/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_provider_setting/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_provider_setting/4","doc":"","ref":"GenAI.ThreadProtocol.html#with_provider_setting/4"},{"type":"function","title":"GenAI.ThreadProtocol.with_provider_settings/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_provider_settings/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_provider_settings/3","doc":"","ref":"GenAI.ThreadProtocol.html#with_provider_settings/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_safety_setting/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_safety_setting/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_safety_setting/3","doc":"","ref":"GenAI.ThreadProtocol.html#with_safety_setting/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_safety_settings/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_safety_settings/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_setting/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_setting/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_setting/3","doc":"Set a hyperparameter option. Some options are model-specific. The value can be a literal or a picker function that dynamically determines the best value based on the context and model. Examples: Parameter.required(name, value) - This sets a required parameter with the specified name and value. Gemini.best_temperature_for(:chain_of_thought) - This uses a picker function to determine the best temperature for the Gemini provider when using the &quot;chain of thought&quot; prompting technique.","ref":"GenAI.ThreadProtocol.html#with_setting/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_settings/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_settings/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_stream_handler/3","doc":"","ref":"GenAI.ThreadProtocol.html#with_stream_handler/3"},{"type":"function","title":"GenAI.ThreadProtocol.with_tool/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_tool/2"},{"type":"function","title":"GenAI.ThreadProtocol.with_tools/2","doc":"","ref":"GenAI.ThreadProtocol.html#with_tools/2"},{"type":"type","title":"GenAI.ThreadProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.ThreadProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Tool","doc":"Represents a function that can be called by the model.","ref":"GenAI.Tool.html"},{"type":"function","title":"GenAI.Tool.apply_node_directives/6","doc":"","ref":"GenAI.Tool.html#apply_node_directives/6"},{"type":"function","title":"GenAI.Tool.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.Tool.html#description/1"},{"type":"function","title":"GenAI.Tool.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.Tool.html#description/2"},{"type":"function","title":"GenAI.Tool.from_json/1","doc":"Extract function from json.","ref":"GenAI.Tool.html#from_json/1"},{"type":"function","title":"GenAI.Tool.from_yaml/1","doc":"Extract function from yaml.","ref":"GenAI.Tool.html#from_yaml/1"},{"type":"function","title":"GenAI.Tool.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.Tool.html#handle/1"},{"type":"function","title":"GenAI.Tool.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.Tool.html#handle/2"},{"type":"function","title":"GenAI.Tool.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.Tool.html#id/1"},{"type":"function","title":"GenAI.Tool.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.Tool.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.Tool.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.Tool.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.Tool.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.Tool.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.Tool.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.Tool.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.Tool.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.Tool.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.Tool.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.Tool.html#name/1"},{"type":"function","title":"GenAI.Tool.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.Tool.html#name/2"},{"type":"function","title":"GenAI.Tool.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.Tool.html#new/1"},{"type":"type","title":"GenAI.Tool.t/0","doc":"","ref":"GenAI.Tool.html#t:t/0"},{"type":"module","title":"GenAI.Tool.Schema.Bool","doc":"Represents a schema for boolean types, converting JSON schema attributes to Elixir struct fields.","ref":"GenAI.Tool.Schema.Bool.html"},{"type":"function","title":"GenAI.Tool.Schema.Bool.from_json/1","doc":"Convert Json map to a GenAI.Tool.Schema.Bool struct, handling naming conventions. Examples Is of Type iex&gt; GenAI.Tool.Schema.Bool . from_json ( %{ &quot;type&quot; =&gt; &quot;boolean&quot; , &quot;description&quot; =&gt; &quot;A boolean value&quot; } ) { :ok , % GenAI.Tool.Schema.Bool { description : &quot;A boolean value&quot; } } Not of Type iex&gt; GenAI.Tool.Schema.Bool . from_json ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) { :error , :unrecognized_type }","ref":"GenAI.Tool.Schema.Bool.html#from_json/1"},{"type":"function","title":"GenAI.Tool.Schema.Bool.is_type/1","doc":"Check if json is of type Examples Is of Type iex&gt; GenAI.Tool.Schema.Bool . is_type ( %{ &quot;type&quot; =&gt; &quot;boolean&quot; } ) true Not of Type iex&gt; GenAI.Tool.Schema.Bool . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) false","ref":"GenAI.Tool.Schema.Bool.html#is_type/1"},{"type":"module","title":"GenAI.Tool.Schema.Enum","doc":"Represents a schema for enum types, converting JSON schema attributes to Elixir struct fields.","ref":"GenAI.Tool.Schema.Enum.html"},{"type":"function","title":"GenAI.Tool.Schema.Enum.from_json/1","doc":"Convert Json map to a GenAI.Tool.Schema.Enum struct, handling naming conventions. Examples Is of Type iex&gt; GenAI.Tool.Schema.Enum . from_json ( %{ &quot;type&quot; =&gt; &quot;string&quot; , &quot;enum&quot; =&gt; [ &quot;value1&quot; , &quot;value2&quot; ] , &quot;description&quot; =&gt; &quot;An enum value&quot; } ) { :ok , % GenAI.Tool.Schema.Enum { type : &quot;string&quot; , enum : [ &quot;value1&quot; , &quot;value2&quot; ] , description : &quot;An enum value&quot; } } Not of Type iex&gt; GenAI.Tool.Schema.Enum . from_json ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) { :error , :unrecognized_type }","ref":"GenAI.Tool.Schema.Enum.html#from_json/1"},{"type":"function","title":"GenAI.Tool.Schema.Enum.is_type/1","doc":"Check if json is of type Examples Is of Type iex&gt; GenAI.Tool.Schema.Enum . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; , &quot;enum&quot; =&gt; [ &quot;value1&quot; , &quot;value2&quot; ] } ) true Not of Type iex&gt; GenAI.Tool.Schema.Enum . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) false","ref":"GenAI.Tool.Schema.Enum.html#is_type/1"},{"type":"type","title":"GenAI.Tool.Schema.Enum.t/0","doc":"","ref":"GenAI.Tool.Schema.Enum.html#t:t/0"},{"type":"module","title":"GenAI.Tool.Schema.Integer","doc":"Represents a schema for integer types, converting JSON schema attributes to Elixir struct fields.","ref":"GenAI.Tool.Schema.Integer.html"},{"type":"function","title":"GenAI.Tool.Schema.Integer.from_json/1","doc":"Convert Json map to a GenAI.Tool.Schema.Integer struct, handling naming conventions. Examples Is of Type iex&gt; GenAI.Tool.Schema.Integer . from_json ( %{ &quot;type&quot; =&gt; &quot;integer&quot; , &quot;minimum&quot; =&gt; 5 , &quot;description&quot; =&gt; &quot;An integer value&quot; } ) { :ok , % GenAI.Tool.Schema.Integer { type : &quot;integer&quot; , minimum : 5 , description : &quot;An integer value&quot; } } Not of Type iex&gt; GenAI.Tool.Schema.Integer . from_json ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) { :error , :unrecognized_type }","ref":"GenAI.Tool.Schema.Integer.html#from_json/1"},{"type":"function","title":"GenAI.Tool.Schema.Integer.is_type/1","doc":"Check if json is of type Examples Is of Type iex&gt; GenAI.Tool.Schema.Enum . is_type ( %{ &quot;type&quot; =&gt; &quot;integer&quot; } ) true Not of Type iex&gt; GenAI.Tool.Schema.Enum . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) false","ref":"GenAI.Tool.Schema.Integer.html#is_type/1"},{"type":"type","title":"GenAI.Tool.Schema.Integer.t/0","doc":"","ref":"GenAI.Tool.Schema.Integer.html#t:t/0"},{"type":"module","title":"GenAI.Tool.Schema.Null","doc":"Represents a schema for null types.","ref":"GenAI.Tool.Schema.Null.html"},{"type":"function","title":"GenAI.Tool.Schema.Null.from_json/1","doc":"Convert Json map to a GenAI.Tool.Schema.Null struct, handling naming conventions. Examples Is of Type iex&gt; GenAI.Tool.Schema.Null . from_json ( %{ &quot;type&quot; =&gt; &quot;null&quot; , &quot;description&quot; =&gt; &quot;A null value&quot; } ) { :ok , % GenAI.Tool.Schema.Null { type : &quot;null&quot; , description : &quot;A null value&quot; } } Not of Type iex&gt; GenAI.Tool.Schema.Null . from_json ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) { :error , :unrecognized_type }","ref":"GenAI.Tool.Schema.Null.html#from_json/1"},{"type":"function","title":"GenAI.Tool.Schema.Null.is_type/1","doc":"Check if json is of type Examples Is of Type iex&gt; GenAI.Tool.Schema.Null . is_type ( %{ &quot;type&quot; =&gt; &quot;null&quot; } ) true Not of Type iex&gt; GenAI.Tool.Schema.Null . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) false","ref":"GenAI.Tool.Schema.Null.html#is_type/1"},{"type":"module","title":"GenAI.Tool.Schema.Number","doc":"Represents a schema for number types, including integers and floating-point numbers.","ref":"GenAI.Tool.Schema.Number.html"},{"type":"function","title":"GenAI.Tool.Schema.Number.from_json/1","doc":"Convert Json map to a GenAI.Tool.Schema.Number struct, handling naming conventions. Examples Is of Type iex&gt; GenAI.Tool.Schema.Number . from_json ( %{ &quot;type&quot; =&gt; &quot;number&quot; , &quot;description&quot; =&gt; &quot;A number value&quot; } ) { :ok , % GenAI.Tool.Schema.Number { description : &quot;A number value&quot; } } Not of Type iex&gt; GenAI.Tool.Schema.Number . from_json ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) { :error , :unrecognized_type }","ref":"GenAI.Tool.Schema.Number.html#from_json/1"},{"type":"function","title":"GenAI.Tool.Schema.Number.is_type/1","doc":"Check if json is of type Examples Is of Type iex&gt; GenAI.Tool.Schema.Number . is_type ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) true Not of Type iex&gt; GenAI.Tool.Schema.Number . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) false","ref":"GenAI.Tool.Schema.Number.html#is_type/1"},{"type":"type","title":"GenAI.Tool.Schema.Number.t/0","doc":"","ref":"GenAI.Tool.Schema.Number.html#t:t/0"},{"type":"module","title":"GenAI.Tool.Schema.Object","doc":"Represents a schema for object types, converting JSON schema attributes to Elixir struct fields.","ref":"GenAI.Tool.Schema.Object.html"},{"type":"function","title":"GenAI.Tool.Schema.Object.from_json/1","doc":"Convert Json map to a GenAI.Tool.Schema.Object struct, handling naming conventions. Examples Is of Type iex&gt; GenAI.Tool.Schema.Object . from_json ( %{ &quot;type&quot; =&gt; &quot;object&quot; , &quot;description&quot; =&gt; &quot;An object value&quot; } ) { :ok , % GenAI.Tool.Schema.Object { type : &quot;object&quot; , description : &quot;An object value&quot; } } Not of Type iex&gt; GenAI.Tool.Schema.Object . from_json ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) { :error , :unrecognized_type }","ref":"GenAI.Tool.Schema.Object.html#from_json/1"},{"type":"function","title":"GenAI.Tool.Schema.Object.is_type/1","doc":"Check if json is of type Examples Is of Type iex&gt; GenAI.Tool.Schema.Object . is_type ( %{ &quot;type&quot; =&gt; &quot;object&quot; } ) true Not of Type iex&gt; GenAI.Tool.Schema.Object . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) false","ref":"GenAI.Tool.Schema.Object.html#is_type/1"},{"type":"type","title":"GenAI.Tool.Schema.Object.t/0","doc":"","ref":"GenAI.Tool.Schema.Object.html#t:t/0"},{"type":"module","title":"GenAI.Tool.Schema.String","doc":"Represents a schema for string types, converting JSON schema attributes to Elixir struct fields.","ref":"GenAI.Tool.Schema.String.html"},{"type":"function","title":"GenAI.Tool.Schema.String.from_json/1","doc":"Convert Json map to a GenAI.Tool.Schema.String struct, handling naming conventions. Examples Is of Type iex&gt; GenAI.Tool.Schema.String . from_json ( %{ &quot;type&quot; =&gt; &quot;string&quot; , &quot;description&quot; =&gt; &quot;A string value&quot; } ) { :ok , % GenAI.Tool.Schema.String { type : &quot;string&quot; , description : &quot;A string value&quot; } } Not of Type iex&gt; GenAI.Tool.Schema.String . from_json ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) { :error , :unrecognized_type }","ref":"GenAI.Tool.Schema.String.html#from_json/1"},{"type":"function","title":"GenAI.Tool.Schema.String.is_type/1","doc":"Check if json is of type Examples Is of Type iex&gt; GenAI.Tool.Schema.String . is_type ( %{ &quot;type&quot; =&gt; &quot;string&quot; } ) true Not of Type iex&gt; GenAI.Tool.Schema.String . is_type ( %{ &quot;type&quot; =&gt; &quot;number&quot; } ) false","ref":"GenAI.Tool.Schema.String.html#is_type/1"},{"type":"type","title":"GenAI.Tool.Schema.String.t/0","doc":"","ref":"GenAI.Tool.Schema.String.html#t:t/0"},{"type":"module","title":"GenAI.Tool.Schema.Type","doc":"Extract known schema types from JSON.","ref":"GenAI.Tool.Schema.Type.html"},{"type":"function","title":"GenAI.Tool.Schema.Type.from_json/1","doc":"","ref":"GenAI.Tool.Schema.Type.html#from_json/1"},{"type":"behaviour","title":"GenAI.Tool.Schema.TypeBehaviour","doc":"Tool Schema Type Behaviour","ref":"GenAI.Tool.Schema.TypeBehaviour.html"},{"type":"callback","title":"GenAI.Tool.Schema.TypeBehaviour.from_json/1","doc":"","ref":"GenAI.Tool.Schema.TypeBehaviour.html#c:from_json/1"},{"type":"callback","title":"GenAI.Tool.Schema.TypeBehaviour.is_type/1","doc":"","ref":"GenAI.Tool.Schema.TypeBehaviour.html#c:is_type/1"},{"type":"protocol","title":"GenAI.ToolProtocol","doc":"","ref":"GenAI.ToolProtocol.html"},{"type":"function","title":"GenAI.ToolProtocol.name/1","doc":"","ref":"GenAI.ToolProtocol.html#name/1"},{"type":"type","title":"GenAI.ToolProtocol.t/0","doc":"All the types that implement this protocol.","ref":"GenAI.ToolProtocol.html#t:t/0"},{"type":"module","title":"GenAI.Types","doc":"VNextGenAI Types","ref":"GenAI.Types.html"},{"type":"type","title":"GenAI.Types.description/0","doc":"Element Description.","ref":"GenAI.Types.html#t:description/0"},{"type":"type","title":"GenAI.Types.details/0","doc":"Error details","ref":"GenAI.Types.html#t:details/0"},{"type":"type","title":"GenAI.Types.error/1","doc":"Error Response","ref":"GenAI.Types.html#t:error/1"},{"type":"type","title":"GenAI.Types.finger_print/0","doc":"Element Finger Print.","ref":"GenAI.Types.html#t:finger_print/0"},{"type":"type","title":"GenAI.Types.handle/0","doc":"Element Handle","ref":"GenAI.Types.html#t:handle/0"},{"type":"type","title":"GenAI.Types.name/0","doc":"Element Name.","ref":"GenAI.Types.html#t:name/0"},{"type":"type","title":"GenAI.Types.ok/1","doc":"Success Response","ref":"GenAI.Types.html#t:ok/1"},{"type":"type","title":"GenAI.Types.result/2","doc":"Call outcome tuple.","ref":"GenAI.Types.html#t:result/2"},{"type":"module","title":"GenAI.Types.Graph","doc":"GenAI.VNext.Graph Type Declarations.","ref":"GenAI.Types.Graph.html"},{"type":"macro","title":"GenAI.Types.Graph.is_graph_id/1","doc":"Guard to check if a value is a valid Graph ID.","ref":"GenAI.Types.Graph.html#is_graph_id/1"},{"type":"macro","title":"GenAI.Types.Graph.is_link_id/1","doc":"Guard to check if a value is a valid Link ID.","ref":"GenAI.Types.Graph.html#is_link_id/1"},{"type":"macro","title":"GenAI.Types.Graph.is_node_id/1","doc":"Guard to check if a value is a valid Node ID.","ref":"GenAI.Types.Graph.html#is_node_id/1"},{"type":"type","title":"GenAI.Types.Graph.graph/0","doc":"A GenAI.VNext.Graph Object","ref":"GenAI.Types.Graph.html#t:graph/0"},{"type":"type","title":"GenAI.Types.Graph.graph_id/0","doc":"A GenAI.VNext.Graph Object Identifier","ref":"GenAI.Types.Graph.html#t:graph_id/0"},{"type":"type","title":"GenAI.Types.Graph.graph_link/0","doc":"A GenAI.VNext.Graph Link Object","ref":"GenAI.Types.Graph.html#t:graph_link/0"},{"type":"type","title":"GenAI.Types.Graph.graph_link_id/0","doc":"A GenAI.VNext.Graph Link Object Identifier","ref":"GenAI.Types.Graph.html#t:graph_link_id/0"},{"type":"type","title":"GenAI.Types.Graph.graph_node/0","doc":"A GenAI.VNext.Graph Node Object","ref":"GenAI.Types.Graph.html#t:graph_node/0"},{"type":"type","title":"GenAI.Types.Graph.graph_node_id/0","doc":"A GenAI.VNext.Graph Node Object Identifier","ref":"GenAI.Types.Graph.html#t:graph_node_id/0"},{"type":"type","title":"GenAI.Types.Graph.link_label/0","doc":"GenAI.VNext.Graph Link Label (e.g. &quot;Log Output&quot;)","ref":"GenAI.Types.Graph.html#t:link_label/0"},{"type":"type","title":"GenAI.Types.Graph.link_type/0","doc":"GenAI.VNext.Graph Link Type (e.g. comment, path, etc.)","ref":"GenAI.Types.Graph.html#t:link_type/0"},{"type":"module","title":"GenAI.VNext.Graph","doc":"A graph data structure for representing AI graphs, threads, conversations, uml, etc. Utility Class","ref":"GenAI.VNext.Graph.html"},{"type":"function","title":"GenAI.VNext.Graph.add_link/3","doc":"Add a link to the graph. Examples iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node1 = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; node2 = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node1 ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node2 ) ...&gt; link = GenAI.Graph.Link . new ( node1 . id , node2 . id ) ...&gt; graph = GenAI.VNext.Graph . add_link ( graph , link ) ...&gt; GenAI.VNext.Graph . link ( graph , link . id ) { :ok , link }","ref":"GenAI.VNext.Graph.html#add_link/3"},{"type":"function","title":"GenAI.VNext.Graph.add_node/3","doc":"Add a node to the graph. Examples iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node ) ...&gt; GenAI.VNext.Graph . member? ( graph , node . id ) true","ref":"GenAI.VNext.Graph.html#add_node/3"},{"type":"function","title":"GenAI.VNext.Graph.attach_node/3","doc":"Attach a node to the graph linked to last inserted item. Examples iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; graph = GenAI.VNext.Graph . attach_node ( graph , node ) ...&gt; GenAI.VNext.Graph . member? ( graph , node . id ) true","ref":"GenAI.VNext.Graph.html#attach_node/3"},{"type":"function","title":"GenAI.VNext.Graph.attempt_set_node/4","doc":"","ref":"GenAI.VNext.Graph.html#attempt_set_node/4"},{"type":"function","title":"GenAI.VNext.Graph.by_handle/2","doc":"Obtain node by handle. Examples When Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) , handle : :foo ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node ) ...&gt; GenAI.VNext.Graph . by_handle ( graph , :foo ) { :ok , node } When Not Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; GenAI.VNext.Graph . by_handle ( graph , :foo ) { :error , { :handle , :not_found } }","ref":"GenAI.VNext.Graph.html#by_handle/2"},{"type":"function","title":"GenAI.VNext.Graph.description/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/1 .","ref":"GenAI.VNext.Graph.html#description/1"},{"type":"function","title":"GenAI.VNext.Graph.description/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.description/2 .","ref":"GenAI.VNext.Graph.html#description/2"},{"type":"function","title":"GenAI.VNext.Graph.do_new/1","doc":"","ref":"GenAI.VNext.Graph.html#do_new/1"},{"type":"function","title":"GenAI.VNext.Graph.do_node/2","doc":"","ref":"GenAI.VNext.Graph.html#do_node/2"},{"type":"function","title":"GenAI.VNext.Graph.do_process_node/6","doc":"","ref":"GenAI.VNext.Graph.html#do_process_node/6"},{"type":"function","title":"GenAI.VNext.Graph.handle/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/1 .","ref":"GenAI.VNext.Graph.html#handle/1"},{"type":"function","title":"GenAI.VNext.Graph.handle/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.handle/2 .","ref":"GenAI.VNext.Graph.html#handle/2"},{"type":"function","title":"GenAI.VNext.Graph.head/1","doc":"","ref":"GenAI.VNext.Graph.html#head/1"},{"type":"function","title":"GenAI.VNext.Graph.id/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.id/1 .","ref":"GenAI.VNext.Graph.html#id/1"},{"type":"function","title":"GenAI.VNext.Graph.inspect_custom_details/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_custom_details/2 .","ref":"GenAI.VNext.Graph.html#inspect_custom_details/2"},{"type":"function","title":"GenAI.VNext.Graph.inspect_full_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_full_detail/2 .","ref":"GenAI.VNext.Graph.html#inspect_full_detail/2"},{"type":"function","title":"GenAI.VNext.Graph.inspect_high_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_high_detail/2 .","ref":"GenAI.VNext.Graph.html#inspect_high_detail/2"},{"type":"function","title":"GenAI.VNext.Graph.inspect_low_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_low_detail/2 .","ref":"GenAI.VNext.Graph.html#inspect_low_detail/2"},{"type":"function","title":"GenAI.VNext.Graph.inspect_medium_detail/2","doc":"See GenAI.Graph.NodeProtocol.DefaultProvider.inspect_medium_detail/2 .","ref":"GenAI.VNext.Graph.html#inspect_medium_detail/2"},{"type":"function","title":"GenAI.VNext.Graph.last_link/1","doc":"","ref":"GenAI.VNext.Graph.html#last_link/1"},{"type":"function","title":"GenAI.VNext.Graph.last_node/1","doc":"","ref":"GenAI.VNext.Graph.html#last_node/1"},{"type":"function","title":"GenAI.VNext.Graph.link/2","doc":"Obtain link by id. Examples When Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node1 = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; node2 = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node1 ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node2 ) ...&gt; link = GenAI.Graph.Link . new ( node1 . id , node2 . id ) ...&gt; graph = GenAI.VNext.Graph . add_link ( graph , link ) ...&gt; GenAI.VNext.Graph . link ( graph , link . id ) { :ok , link } When Not Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; GenAI.VNext.Graph . link ( graph , UUID . uuid4 ( ) ) { :error , { :link , :not_found } }","ref":"GenAI.VNext.Graph.html#link/2"},{"type":"function","title":"GenAI.VNext.Graph.link_by_handle/2","doc":"Obtain link by handle. Examples When Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node1 = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; node2 = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node1 ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node2 ) ...&gt; link = GenAI.Graph.Link . new ( node1 . id , node2 . id , handle : :bar ) ...&gt; graph = GenAI.VNext.Graph . add_link ( graph , link ) ...&gt; GenAI.VNext.Graph . link_by_handle ( graph , :bar ) { :ok , link } When Not Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; GenAI.VNext.Graph . link_by_handle ( graph , :bar ) { :error , { :handle , :not_found } }","ref":"GenAI.VNext.Graph.html#link_by_handle/2"},{"type":"function","title":"GenAI.VNext.Graph.member?/2","doc":"Check if a node is a member of the graph. Examples iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node ) ...&gt; GenAI.VNext.Graph . member? ( graph , node . id ) true iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; GenAI.VNext.Graph . member? ( graph , UUID . uuid4 ( ) ) false","ref":"GenAI.VNext.Graph.html#member?/2"},{"type":"function","title":"GenAI.VNext.Graph.name/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/1 .","ref":"GenAI.VNext.Graph.html#name/1"},{"type":"function","title":"GenAI.VNext.Graph.name/2","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.name/2 .","ref":"GenAI.VNext.Graph.html#name/2"},{"type":"function","title":"GenAI.VNext.Graph.new/1","doc":"Callback implementation for GenAI.Graph.NodeBehaviour.new/1 .","ref":"GenAI.VNext.Graph.html#new/1"},{"type":"function","title":"GenAI.VNext.Graph.node/2","doc":"Obtain node by id. Examples When Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; node = GenAI.Graph.Node . new ( id : UUID . uuid4 ( ) ) ...&gt; graph = GenAI.VNext.Graph . add_node ( graph , node ) ...&gt; GenAI.VNext.Graph . node ( graph , node . id ) { :ok , node } When Not Found iex&gt; graph = GenAI.VNext.Graph . new ( ) ...&gt; GenAI.VNext.Graph . node ( graph , UUID . uuid4 ( ) ) { :error , { :node , :not_found } }","ref":"GenAI.VNext.Graph.html#node/2"},{"type":"function","title":"GenAI.VNext.Graph.nodes/2","doc":"","ref":"GenAI.VNext.Graph.html#nodes/2"},{"type":"function","title":"GenAI.VNext.Graph.nodes!/2","doc":"","ref":"GenAI.VNext.Graph.html#nodes!/2"},{"type":"function","title":"GenAI.VNext.Graph.process_node/6","doc":"","ref":"GenAI.VNext.Graph.html#process_node/6"},{"type":"function","title":"GenAI.VNext.Graph.setting/4","doc":"","ref":"GenAI.VNext.Graph.html#setting/4"},{"type":"type","title":"GenAI.VNext.Graph.t/0","doc":"","ref":"GenAI.VNext.Graph.html#t:t/0"},{"type":"exception","title":"GenAI.Graph.Exception","doc":"Generic Graph Exception","ref":"GenAI.Graph.Exception.html"},{"type":"exception","title":"GenAI.RequestError","doc":"Custom error for handling request errors in the GenAI module.","ref":"GenAI.RequestError.html"},{"type":"extras","title":"Contributing","doc":"Please feel free to submit an feature request/issues/clarification items you ahve under Issues! ^_^. GenAI Core Library GenAI Core contains base protocols used by GenAI to simplify the process of merging in new features and functionality from the genai_core_vnext repo. The intent of the core library is to isolate out core functionality to make extensibility more straight forward and to isolate the exllama support as an add to make using with livebook more straight forward.","ref":"readme.html"},{"type":"extras","title":"Change Log","doc":"0.0.1 - Initial Release Initial Text Only Generation. 0.0.2 - Local Model Support Local LLama support added for pulling in gguf models for inference. 0.0.3 - Vision Support and Internal Structure Update Warning - This update may break existing code. Added Vision support for OpenAI, Gemini, and Anthropic. Updated internal structure to allow for more advanced use cases such as prompt loops/fitness checks, added support for how to handel local models, etc. 0.2.0 - Refactor Directed Graph Session to allow future advanced feature. Streamline how providers are added with use macros.","ref":"changelog.html"},{"type":"extras","title":"Todo","doc":"[ ] More advanced link mechanism to point to distant siblings, ancestors etc. [ ] A Graph Root object builds a full node tree going into nested children. 432 -&gt; [nodea, nodeb, nodec, 432] [ ] we can use a patch builder that walks across nodes recursively [ ] Anchored link support $uuid/path [ ] scoped handles? (local_handle, tag, ...) [ ] document directive process [ ] concrete, dynamic, etc. [ ] basic implementation or process_nodes (just trace path and set as an artifact) Runtime position?","ref":"todo.html"},{"type":"extras","title":"CONTRIBUTING","doc":"","ref":"contributing.html"},{"type":"extras","title":"CONTRIBUTING - Contributing to the GenAI Elixir Library","doc":"We welcome contributions to the GenAI library! Here are some guidelines to help you get started: Reporting Issues If you encounter any bugs or unexpected behavior while using the library, please open an issue on the GitHub repository . When reporting an issue, please provide the following information: A clear description of the problem you are experiencing. Steps to reproduce the issue. Any relevant code snippets or error messages. Your Elixir version and operating system. Submitting Pull Requests If you would like to contribute code to the library, please follow these steps: Fork the repository. Create a new branch for your changes. Make your changes and commit them with descriptive commit messages. Push your changes to your fork. Submit a pull request to the main branch of the noizu-labs-ml/genai repository. Please ensure that your pull request adheres to the following guidelines: Your code should be well-formatted and follow Elixir coding conventions. Your code should be covered by tests. Your pull request should include a clear description of the changes you have made. Code of Conduct Please note that this project is governed by a Code of Conduct. By participating in this project, you agree to abide by its terms. Getting Help If you have any questions or need help with contributing, please feel free to open an issue on the GitHub repository or reach out to the maintainers. We appreciate your contributions to the GenAI library!","ref":"contributing.html#contributing-to-the-genai-elixir-library"},{"type":"extras","title":"LICENSE","doc":"MIT License Copyright (c) 2023 noizu-labs Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}]